/**@license
 *       __ _____                     ________                              __
 *      / // _  /__ __ _____ ___ __ _/__  ___/__ ___ ______ __ __  __ ___  / /
 *  __ / // // // // // _  // _// // / / // _  // _//     // //  \/ // _ \/ /
 * /  / // // // // // ___// / / // / / // ___// / / / / // // /\  // // / /__
 * \___//____ \\___//____//_/ _\_  / /_//____//_/ /_/ /_//_//_/ /_/ \__\_\___/
 *           \/              /____/                              version 1.7.2
 *
 * This file is part of jQuery Terminal. http://terminal.jcubic.pl
 *
 * Copyright (c) 2010-2017 Jakub Jankiewicz <http://jcubic.pl/me>
 * Released under the MIT license
 *
 * Contains:
 *
 * Storage plugin Distributed under the MIT License
 * Copyright (c) 2010 Dave Schindler
 *
 * jQuery Timers licenced with the WTFPL
 * <http://jquery.offput.ca/timers/>
 *
 * Cross-Browser Split 1.1.1
 * Copyright 2007-2012 Steven Levithan <stevenlevithan.com>
 * Available under the MIT License
 *
 * jQuery Caret
 * Copyright (c) 2009, Gideon Sireling
 * 3 clause BSD License
 *
 * sprintf.js
 * Copyright (c) 2007-2013 Alexandru Marasteanu <hello at alexei dot ro>
 * licensed under 3 clause BSD license
 *
 * Date: Sun, 17 Sep 2017 19:54:42 +0000
 */
(function(e){var n=function(){if(!n.cache.hasOwnProperty(arguments[0])){n.cache[arguments[0]]=n.parse(arguments[0])}return n.format.call(null,n.cache[arguments[0]],arguments)};n.format=function(e,t){var o=1,a=e.length,s="",l,f=[],c,u,p,m,d,h;for(c=0;c<a;c++){s=r(e[c]);if(s==="string"){f.push(e[c])}else if(s==="array"){p=e[c];if(p[2]){l=t[o];for(u=0;u<p[2].length;u++){if(!l.hasOwnProperty(p[2][u])){throw n('[sprintf] property "%s" does not exist',p[2][u])}l=l[p[2][u]]}}else if(p[1]){l=t[p[1]]}else{l=t[o++]}if(/[^s]/.test(p[8])&&r(l)!=="number"){throw n("[sprintf] expecting number but found %s",r(l))}switch(p[8]){case"b":l=l.toString(2);break;case"c":l=String.fromCharCode(l);break;case"d":l=parseInt(l,10);break;case"e":l=p[7]?l.toExponential(p[7]):l.toExponential();break;case"f":l=p[7]?parseFloat(l).toFixed(p[7]):parseFloat(l);break;case"o":l=l.toString(8);break;case"s":l=(l=String(l))&&p[7]?l.substring(0,p[7]):l;break;case"u":l=l>>>0;break;case"x":l=l.toString(16);break;case"X":l=l.toString(16).toUpperCase();break}l=/[def]/.test(p[8])&&p[3]&&l>=0?" +"+l:l;d=p[4]?p[4]==="0"?"0":p[4].charAt(1):" ";h=p[6]-String(l).length;m=p[6]?i(d,h):"";f.push(p[5]?l+m:m+l)}}return f.join("")};n.cache={};n.parse=function(e){var n=e,t=[],r=[],i=0;while(n){if((t=/^[^\x25]+/.exec(n))!==null){r.push(t[0])}else if((t=/^\x25{2}/.exec(n))!==null){r.push("%")}else if((t=/^\x25(?:([1-9]\d*)\$|\(([^\)]+)\))?(\+)?(0|'[^$])?(-)?(\d+)?(?:\.(\d+))?([b-fosuxX])/.exec(n))!==null){if(t[2]){i|=1;var o=[],a=t[2],s=[];if((s=/^([a-z_][a-z_\d]*)/i.exec(a))!==null){o.push(s[1]);while((a=a.substring(s[0].length))!==""){if((s=/^\.([a-z_][a-z_\d]*)/i.exec(a))!==null){o.push(s[1])}else if((s=/^\[(\d+)\]/.exec(a))!==null){o.push(s[1])}else{throw"[sprintf] huh?"}}}else{throw"[sprintf] huh?"}t[2]=o}else{i|=2}if(i===3){throw"[sprintf] mixing positional and named placeholders is not (yet) supported"}r.push(t)}else{throw"[sprintf] huh?"}n=n.substring(t[0].length)}return r};var t=function(e,t,r){r=t.slice(0);r.splice(0,0,e);return n.apply(null,r)};function r(e){return Object.prototype.toString.call(e).slice(8,-1).toLowerCase()}function i(e,n){for(var t=[];n>0;t[--n]=e){}return t.join("")}e.sprintf=n;e.vsprintf=t})(typeof global!=="undefined"?global:window);(function(e){if(typeof define==="function"&&define.amd){define(["jquery"],e)}else if(typeof module==="object"&&module.exports){module.exports=function(n,t){if(t===undefined){if(typeof window!=="undefined"){t=require("jquery")}else{t=require("jquery")(n)}}e(t);return t}}else{e(jQuery)}})(function(e,n){"use strict";function t(){var n=e.Callbacks();var t=false;this.resolve=function(){n.fire();t=true};this.add=function(e){if(t){e()}else{n.add(e)}}}e.omap=function(n,t){var r={};e.each(n,function(e,i){r[e]=t.call(n,e,i)});return r};var r={clone_object:function(n){var t={};if(typeof n==="object"){if(e.isArray(n)){return this.clone_array(n)}else if(n===null){return n}else{for(var r in n){if(e.isArray(n[r])){t[r]=this.clone_array(n[r])}else if(typeof n[r]==="object"){t[r]=this.clone_object(n[r])}else{t[r]=n[r]}}}}return t},clone_array:function(n){if(!e.isFunction(Array.prototype.map)){throw new Error("Your browser don't support ES5 array map "+"use es5-shim")}return n.slice(0).map(function(e){if(typeof e==="object"){return this.clone_object(e)}else{return e}}.bind(this))}};var i=function(e){return r.clone_object(e)};var o=function(){try{var e="test",n=window.localStorage;n.setItem(e,"1");n.removeItem(e);return true}catch(e){return false}};var a=o();function s(e,n){var t;if(typeof e==="string"&&typeof n==="string"){localStorage[e]=n;return true}else if(typeof e==="object"&&typeof n==="undefined"){for(t in e){if(e.hasOwnProperty(t)){localStorage[t]=e[t]}}return true}return false}function l(e,n){var t,r,i;t=new Date;t.setTime(t.getTime()+31536e6);r="; expires="+t.toGMTString();if(typeof e==="string"&&typeof n==="string"){document.cookie=e+"="+n+r+"; path=/";return true}else if(typeof e==="object"&&typeof n==="undefined"){for(i in e){if(e.hasOwnProperty(i)){document.cookie=i+"="+e[i]+r+"; path=/"}}return true}return false}function f(e){return localStorage[e]}function c(e){var n,t,r,i;n=e+"=";t=document.cookie.split(";");for(r=0;r<t.length;r++){i=t[r];while(i.charAt(0)===" "){i=i.substring(1,i.length)}if(i.indexOf(n)===0){return i.substring(n.length,i.length)}}return null}function u(e){return delete localStorage[e]}function p(e){return l(e,"",-1)}e.extend({Storage:{set:a?s:l,get:a?f:c,remove:a?u:p}});var m=e;m.fn.extend({everyTime:function(e,n,t,r,i){return this.each(function(){m.timer.add(this,e,n,t,r,i)})},oneTime:function(e,n,t){return this.each(function(){m.timer.add(this,e,n,t,1)})},stopTime:function(e,n){return this.each(function(){m.timer.remove(this,e,n)})}});m.extend({timer:{guid:1,global:{},regex:/^([0-9]+)\s*(.*s)?$/,powers:{ms:1,cs:10,ds:100,s:1e3,das:1e4,hs:1e5,ks:1e6},timeParse:function(e){if(e===n||e===null){return null}var t=this.regex.exec(m.trim(e.toString()));if(t[2]){var r=parseInt(t[1],10);var i=this.powers[t[2]]||1;return r*i}else{return e}},add:function(e,n,t,r,i,o){var a=0;if(m.isFunction(t)){if(!i){i=r}r=t;t=n}n=m.timer.timeParse(n);if(typeof n!=="number"||isNaN(n)||n<=0){return}if(i&&i.constructor!==Number){o=!!i;i=0}i=i||0;o=o||false;if(!e.$timers){e.$timers={}}if(!e.$timers[t]){e.$timers[t]={}}r.$timerID=r.$timerID||this.guid++;var s=function(){if(o&&s.inProgress){return}s.inProgress=true;if(++a>i&&i!==0||r.call(e,a)===false){m.timer.remove(e,t,r)}s.inProgress=false};s.$timerID=r.$timerID;if(!e.$timers[t][r.$timerID]){e.$timers[t][r.$timerID]=window.setInterval(s,n)}if(!this.global[t]){this.global[t]=[]}this.global[t].push(e)},remove:function(e,n,t){var r=e.$timers,i;if(r){if(!n){for(var o in r){if(r.hasOwnProperty(o)){this.remove(e,o,t)}}}else if(r[n]){if(t){if(t.$timerID){window.clearInterval(r[n][t.$timerID]);delete r[n][t.$timerID]}}else{for(var a in r[n]){if(r[n].hasOwnProperty(a)){window.clearInterval(r[n][a]);delete r[n][a]}}}for(i in r[n]){if(r[n].hasOwnProperty(i)){break}}if(!i){i=null;delete r[n]}}for(i in r){if(r.hasOwnProperty(i)){break}}if(!i){e.$timers=null}}}}});if(/(msie) ([\w.]+)/.exec(navigator.userAgent.toLowerCase())){m(window).one("unload",function(){var e=m.timer.global;for(var n in e){if(e.hasOwnProperty(n)){var t=e[n],r=t.length;while(--r){m.timer.remove(t[r],n)}}}})}(function(e){if(!String.prototype.split.toString().match(/\[native/)){return}var n=String.prototype.split,t=/()??/.exec("")[1]===e,r;r=function(r,i,o){if(Object.prototype.toString.call(i)!=="[object RegExp]"){return n.call(r,i,o)}var a=[],s=(i.ignoreCase?"i":"")+(i.multiline?"m":"")+(i.extended?"x":"")+(i.sticky?"y":""),l=0,f,c,u,p;i=new RegExp(i.source,s+"g");r+="";if(!t){f=new RegExp("^"+i.source+"$(?!\\s)",s)}o=o===e?-1>>>0:o>>>0;while(c=i.exec(r)){u=c.index+c[0].length;if(u>l){a.push(r.slice(l,c.index));if(!t&&c.length>1){c[0].replace(f,function(){for(var n=1;n<arguments.length-2;n++){if(arguments[n]===e){c[n]=e}}})}if(c.length>1&&c.index<r.length){Array.prototype.push.apply(a,c.slice(1))}p=c[0].length;l=u;if(a.length>=o){break}}if(i.lastIndex===c.index){i.lastIndex++}}if(l===r.length){if(p||!i.test("")){a.push("")}}else{a.push(r.slice(l))}return a.length>o?a.slice(0,o):a};String.prototype.split=function(e,n){return r(this,e,n)};return r})();e.fn.caret=function(e){var n=this[0];var t=n.contentEditable==="true";if(arguments.length===0){if(window.getSelection){if(t){n.focus();var r=window.getSelection().getRangeAt(0),i=r.cloneRange();i.selectNodeContents(n);i.setEnd(r.endContainer,r.endOffset);return i.toString().length}return n.selectionStart}if(document.selection){n.focus();if(t){var r=document.selection.createRange(),i=document.body.createTextRange();i.moveToElementText(n);i.setEndPoint("EndToEnd",r);return i.text.length}var e=0,o=n.createTextRange(),i=document.selection.createRange().duplicate(),a=i.getBookmark();o.moveToBookmark(a);while(o.moveStart("character",-1)!==0)e++;return e}return 0}if(e===-1)e=this[t?"text":"val"]().length;if(window.getSelection){if(t){n.focus();window.getSelection().collapse(n.firstChild,e)}else n.setSelectionRange(e,e)}else if(document.body.createTextRange){var o=document.body.createTextRange();o.moveToElementText(n);o.moveStart("character",e);o.collapse(true);o.select()}if(!t)n.focus();return e};var d=window.requestAnimationFrame||window.mozRequestAnimationFrame||window.webkitRequestAnimationFrame||function(e){return window.setTimeout(e,20)};e.fn.resizer=function(n){var t=arguments[0]==="unbind";if(!t&&!e.isFunction(n)){throw new Error('Invalid argument, it need to a function of string "unbind".')}return this.each(function(){var r=e(this);if(t){e(this).removeData("callbacks").find(".resizer").remove()}else if(r.data("callbacks")){e(this).data("callbacks").push(n)}else{r.data("callbacks",[n]);var i=this;var o=e("<div/>").addClass("resizer").appendTo(this)[0];var a="position: absolute; left: 0; top: 0; right: 0; bottom: 0; "+"overflow: hidden; z-index: -1; visibility: hidden;";var s="position: absolute; left: 0; top: 0; transition: 0s;";o.style.cssText=a;o.innerHTML='<div class="resize-sensor-expand" style="'+a+'">'+'<div style="'+s+'"></div>'+"</div>"+'<div class="resize-sensor-shrink" style="'+a+'">'+'<div style="'+s+' width: 200%; height: 200%"></div>'+"</div>";var l=o.childNodes[0];var f=l.childNodes[0];var c=o.childNodes[1];var u,p,m,h;var v=i.offsetWidth;var g=i.offsetHeight;var y=function(){f.style.width="100000px";f.style.height="100000px";l.scrollLeft=1e5;l.scrollTop=1e5;c.scrollLeft=1e5;c.scrollTop=1e5};y();var w=function(){p=0;if(!u){return}v=m;g=h;var e=r.data("callbacks");if(e&&e.length){e.forEach(function(e){e()})}};var b=function(){m=i.offsetWidth;h=i.offsetHeight;u=m!==v||h!==g;if(u&&!p){p=d(w)}y()};e(l).on("scroll",b);e(c).on("scroll",b)}})};function h(e){e.attr({role:"presentation","aria-hidden":"true"})}function v(){var n=[].slice.call(arguments);var t=0;e.extend(this,{get:function(){return n},index:function(){return t},rotate:function(e){if(!e){var r=n.filter(function(e){return typeof e!=="undefined"});if(!r.length){return}}if(n.length===1){return n[0]}else{if(t===n.length-1){t=0}else{++t}if(typeof n[t]!=="undefined"){return n[t]}else{return this.rotate(true)}}},length:function(){return n.length},remove:function(e){delete n[e]},set:function(e){for(var r=n.length;r--;){if(n[r]===e){t=r;return}}this.append(e);t=n.length-1},front:function(){if(n.length){var e=t;var r=false;while(!n[e]){e++;if(e>n.length){if(r){break}e=0;r=true}}return n[e]}},map:function(e){return n.filter(Boolean).map(e)},forEach:function(e){n.filter(Boolean).forEach(e)},append:function(e){n.push(e)}})}function g(n){var t=n instanceof Array?n:n?[n]:[];e.extend(this,{data:function(){return t},map:function(n){return e.map(t,n)},size:function(){return t.length},pop:function(){if(t.length===0){return null}else{var e=t[t.length-1];t=t.slice(0,t.length-1);return e}},push:function(e){t=t.concat([e]);return e},top:function(){return t.length>0?t[t.length-1]:null},clone:function(){return new g(t.slice(0))}})}function y(n,t,r){var i=true;var o="";if(typeof n==="string"&&n!==""){o=n+"_"}o+="commands";var a;if(r){a=[]}else{a=e.Storage.get(o);a=a?JSON.parse(a):[]}var s=a.length-1;e.extend(this,{append:function(n){if(i){if(a[a.length-1]!==n){a.push(n);if(t&&a.length>t){a=a.slice(-t)}s=a.length-1;if(!r){e.Storage.set(o,JSON.stringify(a))}}}},set:function(n){if(n instanceof Array){a=n;if(!r){e.Storage.set(o,JSON.stringify(a))}}},data:function(){return a},reset:function(){s=a.length-1},last:function(){return a[a.length-1]},end:function(){return s===a.length-1},position:function(){return s},current:function(){return a[s]},next:function(){if(s<a.length-1){++s}if(s!==-1){return a[s]}},previous:function(){var e=s;if(s>0){--s}if(e!==-1){return a[s]}},clear:function(){a=[];this.purge()},enabled:function(){return i},enable:function(){i=true},purge:function(){if(!r){e.Storage.remove(o)}},disable:function(){i=false}})}var w=0;e.fn.cmd=function(t){var r=this;var i=r.data("cmd");if(i){return i}var o=w++;r.addClass("cmd");r.append('<span class="prompt"></span><span></span>'+'<span class="cursor">&nbsp;</span><span></span>');h(r.find("span").not(":eq(0)"));var a=e("<textarea>").attr({autocapitalize:"off",spellcheck:"false",tabindex:1}).addClass("clipboard").appendTo(r);if(t.width){r.width(t.width)}var s;var l;var f=r.find(".prompt");var c=false;var u="";var p=null;var m;var d=t.mask||false;var v="";var g;var b="";var _=0;var k;var x;var T=t.historySize||60;var E,C;var R=r.find(".cursor");var S;var A=0;function F(){var n=e("<span>&nbsp;</span>").appendTo(r);var t=n[0].getBoundingClientRect();n.remove();return t}function L(){var e;if((e=window.getSelection())&&e.focusNode!==null){return e.focusOffset}}function j(n){var t=L();var i;var o=F();var a=o.height;var s=r.offset();var l=Math.floor((n.pageY-s.top)/a);if(e.isNumeric(t)){var f=e(n.target).closest('[role="presentation"]');if(f.is("div")){i=t}else if(f.next().is(".cursor")){i=t}else if(f.is(".cursor")){return _}else if(f.prev().is(".cursor")){return _+t}else{i=0}}else{return v.length}var c=oe(v);var u;if(l>0&&c.length>1){u=i+c.slice(0,l).reduce(function(e,n){return e+n.length},0)}else{u=i}var p=v.replace(/\t/g,"\0\0\0\0").replace(/\n/,"");var m=p.slice(0,u);var d=m.replace(/\x00{4}/g,"\t").replace(/\x00+/,"").length;var h=v.length;return d>h?h:d}function O(e){if(e.key){var n=e.key.toUpperCase();if(n==="CONTROL"){return"CTRL"}else{var t=[];if(e.ctrlKey){t.push("CTRL")}if(e.metaKey&&n!=="META"){t.push("META")}if(e.shiftKey&&n!=="SHIFT"){t.push("SHIFT")}if(e.altKey&&n!=="ALT"){t.push("ALT")}if(e.key){if(n==="DEL"){t.push("DELETE")}else{t.push(n)}}return t.join("+")}}}var z;var P={"ALT+D":function(){r.set(v.slice(0,_)+v.slice(_).replace(/ *[^ ]+ *(?= )|[^ ]+$/,""),true);return false},ENTER:function(){if(C&&v&&!d&&(e.isFunction(t.historyFilter)&&t.historyFilter(v))||t.historyFilter instanceof RegExp&&v.match(t.historyFilter)||!t.historyFilter){C.append(v)}var n=v;C.reset();ke="";ye=true;r.set("");if(t.commands){t.commands(n)}if(e.isFunction(k)){fe()}e(".clipboard").val("");return false},"SHIFT+ENTER":function(){r.insert("\n");return true},BACKSPACE:function(){if(c){u=u.slice(0,-1);ne()}else if(v!==""&&_>0){r["delete"](-1)}r.oneTime(1,function(){ye=true})},TAB:function(){r.insert("\t")},"CTRL+D":function(){r["delete"](1);return false},DELETE:function(){r["delete"](1);return true},ARROWUP:$,UP:$,"CTRL+P":$,ARROWDOWN:U,DOWN:U,"CTRL+N":U,ARROWLEFT:K,LEFT:K,"CTRL+B":K,"CTRL+ARROWLEFT":function(){var e=_-1;var n=0;if(v[e]===" "){--e}for(var t=e;t>0;--t){if(v[t]===" "&&v[t+1]!==" "){n=t+1;break}else if(v[t]==="\n"&&v[t+1]!=="\n"){n=t;break}}r.position(n)},"CTRL+R":function(){if(c){re(true)}else{m=k;ne();g=v;r.set("");le();c=true}return false},"CTRL+G":function(){if(c){k=m;fe();r.set(g);le();c=false;u="";return false}},ARROWRIGHT:J,"CTRL+F":J,RIGHT:J,"CTRL+ARROWRIGHT":function(){if(v[_]===" "){++_}var e=/\S[\n\s]{2,}|[\n\s]+\S?/;var n=v.slice(_).match(e);if(!n||n[0].match(/^\s+$/)){r.position(v.length)}else if(n[0][0]!==" "){_+=n.index+1}else{_+=n.index+n[0].length-1;if(n[0][n[0].length-1]!==" "){--_}}le()},F12:I,END:G,"CTRL+E":G,HOME:Y,"CTRL+A":Y,"SHIFT+INSERT":N,"CTRL+SHIFT+T":I,"CTRL+W":function(){if(v!==""&&_!==0){var e=v.slice(0,_).match(/([^ ]+ *$)/);if(e[0].length){b=r["delete"](-e[0].length);V(r,b)}}return false},"CTRL+H":function(){if(v!==""&&_>0){r["delete"](-1)}return false},"CTRL+X":I,"CTRL+C":I,"CTRL+T":I,"CTRL+Y":function(){if(b!==""){r.insert(b)}},"CTRL+V":N,"META+V":N,"CTRL+K":function(){if(v.length-_){b=r["delete"](v.length-_);V(r,b)}return false},"CTRL+U":function(){if(v!==""&&_!==0){b=r["delete"](-_);V(r,b)}return false},"CTRL+TAB":function(){return false},"META+`":I,"META+R":I,"META+L":I};function I(){return true}function N(){a.val("");A=0;a.trigger("focus",[true]);a.on("input",function e(n){ce(n);a.off("input",e)});return true}function $(){if(pe){g=v;r.set(C.current())}else{r.set(C.previous())}pe=false;return false}function U(){r.set(C.end()?g:C.next());return false}function K(){if(_>0){r.position(-1,true);le()}}function J(){if(_<v.length){r.position(1,true)}return false}function Y(){r.position(0)}function G(){r.position(v.length)}function X(){var e=a.is(":focus");if(x){if(!e){}r.oneTime(10,function(){if(!a.is(":focus")&&x){a.trigger("focus",[true])}})}else if(e&&(B||!x)){a.trigger("blur",[true])}}function Q(){r.oneTime(10,function(){if(a.val()!==v){a.val(v)}if(x){r.oneTime(10,function(){try{a.caret(_)}catch(e){}})}})}if(H&&!q){S=function(e){if(e){R.addClass("blink")}else{R.removeClass("blink")}}}else{var Z=false;S=function(e){if(e&&!Z){Z=true;R.addClass("inverted blink");r.everyTime(500,"blink",ee)}else if(Z&&!e){Z=false;r.stopTime("blink",ee);R.removeClass("inverted blink")}}}function ee(){R.toggleClass("inverted")}function ne(){k="(reverse-i-search)`"+u+"': ";fe()}function te(){k=m;c=false;p=null;u=""}function re(n){var t=C.data();var i,o;var a=t.length;if(n&&p>0){a-=p}if(u.length>0){for(var s=u.length;s>0;s--){o=e.terminal.escape_regex(u.substring(0,s));i=new RegExp(o);for(var l=a;l--;){if(i.test(t[l])){p=t.length-l;r.position(t[l].indexOf(o));r.set(t[l],true);le();if(u.length!==s){u=u.substring(0,s);ne()}return}}}}u=""}function ie(){var e=r.find(".prompt").text("&nbsp;");var n=r.width();var t=e[0].getBoundingClientRect().width;s=Math.floor(n/t);fe()}function oe(n){function t(n){return e.terminal.split_equal(n,s)}var r=f.text();var i=new RegExp("^"+e.terminal.escape_regex(r));var o;if(n.match(/\n/)){var a=n.split("\n");var c=s-l-1;for(var u=0;u<a.length-1;++u){a[u]+=" "}if(D(a[0])>c){o=t(r+a[0],s);o[0]=o[0].replace(i,"")}else{o=[a[0]]}for(u=1;u<a.length;++u){if(a[u].length>s){o=o.concat(t(a[u],s))}else{o.push(a[u])}}}else{o=t(r+n,s);o[0]=o[0].replace(i,"")}return o}function ae(n){n=e.terminal.escape_formatting(n);try{return e.terminal.apply_formatters(n)}catch(e){alert(e.message+"\n"+(e.stack?e.stack:e))}}function se(n){return e.terminal.format(e.terminal.encode(n))}var le=function(){var t=R.prev();var i=R.next();function o(n,t,r){return e.terminal.substring(n,t,r)}function a(e,n){var r=e.length;e=ae(e);if(n===r){t.html(se(e));R.html("&nbsp;");i.html("")}else if(n===0){t.html("");R.html(se(o(e,0,1)));i.html(se(o(e,1)))}else{var a=o(e,0,n);t.html(se(a));var s=o(e,n,n+1);R.html(se(s));if(n===e.length-1){i.html("")}else{i.html(se(o(e,n+1)))}}}function f(e){return'<div role="presentation">'+se(ae(e))+"</div>"}function c(n){var t=i;e.each(n,function(n,r){t=e(f(r)).insertAfter(t)})}function u(n){e.each(n,function(e,n){t.before(f(n))})}return function(){var o;switch(typeof d){case"boolean":o=d?v.replace(/./g,"*"):v;break;case"string":o=v.replace(/./g,d);break}var p;r.find("div").remove();t.html("");if(D(o)>s-l-1||o.match(/\n/)){var m=o.match(/\t/g);var h=m?m.length*3:0;if(m){o=o.replace(/\t/g,"\0\0\0\0")}var g=oe(o);if(m){g=e.map(g,function(e){return e.replace(/\x00\x00\x00\x00/g,"\t")})}var y=g[0].length;if(y===0&&g.length===1){}else if(_<y){a(g[0],_);c(g.slice(1))}else if(_===y){t.before(f(g[0]));a(g[1]||"",0);if(g.length>1){c(g.slice(2))}}else{var w=g.length;if(_<y){a(g[0],_);c(g.slice(1))}else if(_===y){t.before(f(g[0]));a(g[1],0);c(g.slice(2))}else{var b=g.slice(-1)[0];var k=o.length-_-h;var x=b.length;var T=0;if(k<=x){u(g.slice(0,-1));if(x===k){T=0}else{T=x-k}a(b,T)}else if(w===3){var E=se(g[0]);t.before('<div role="presentation">'+E+"</div>");a(g[1],_-y-1);E=se(ae(g[2]));i.after('<div role="presentation">'+E+"</div>")}else{var C;var S;T=_;for(p=0;p<g.length;++p){var A=g[p].length;if(T>A){T-=A}else{break}}S=g[p];C=p;if(T===S.length){T=0;S=g[++C];if(S===n){var F=e.terminal.defaults.strings.redrawError;throw new Error(F)}}a(S,T);u(g.slice(0,C));c(g.slice(C+1))}}}}else if(o===""){t.html("");R.html("&nbsp;");i.html("")}else{a(o,_)}}}();var fe=function(){function n(n){var t=e.terminal.split_equal(e.terminal.encode(n),s);var r=t.slice(-1).map(e.terminal.format)[0];var i=t.slice(0,-1).map(function(n){n=e.terminal.format(n);if(n.match(/class="/)){return n.replace(/class="/,'class="line ')}else{return n.replace(/^<span/,'<span class="line"')}}).concat([r]).join("\n");f.html(i);l=D(e("<span>"+r+"</span>").text())}return function(){switch(typeof k){case"string":n(k);break;case"function":k(n);break}}}();function ce(){if(A++>0){return}if(r.isenabled()){var e=r.find("textarea");if(!e.is(":focus")){e.trigger("focus",[true])}r.oneTime(100,function(){r.insert(e.val());e.val(v);Q()})}}function ue(){if(e.isFunction(t.onCommandChange)){t.onCommandChange(v)}}e.extend(r,{name:function(e){if(e!==n){E=e;var i=C&&C.enabled()||!C;C=new y(e,T,t.history==="memory");if(!i){C.disable()}return r}else{return E}},purge:function(){C.clear();return r},history:function(){return C},delete:function(e,n){var t;if(e===0){return r}else if(e<0){if(_>0){t=v.slice(0,_).slice(e);v=v.slice(0,_+e)+v.slice(_,v.length);if(!n){r.position(_+e)}ue()}}else if(v!==""&&_<v.length){t=v.slice(_).slice(0,e);v=v.slice(0,_)+v.slice(_+e,v.length);ue()}le();Q();return t},set:function(e,t){if(e!==n){v=e;if(!t){r.position(v.length)}le();Q();ue()}return r},keymap:function(n){if(typeof n==="undefined"){return z}else{z=e.extend({},P,e.omap(n||{},function(e,n){return function(t){return n(t,P[e])}}));return r}},insert:function(e,n){if(_===v.length){v+=e}else if(_===0){v=e+v}else{v=v.slice(0,_)+e+v.slice(_)}if(!n){r.position(e.length,true)}else{Q()}le();ue();return r},get:function(){return v},commands:function(e){if(e){t.commands=e;return r}else{return e}},destroy:function(){Te.unbind("keypress.cmd",Ee);Te.unbind("keydown.cmd",xe);Te.unbind("input.cmd",Se);r.stopTime("blink",ee);r.find(".cursor").next().remove().end().prev().remove().end().remove();r.find(".prompt, .clipboard").remove();r.removeClass("cmd").removeData("cmd").off(".cmd");return r},prompt:function(e){if(e===n){return k}else{if(typeof e==="string"||typeof e==="function"){k=e}else{throw new Error("prompt must be a function or string")}fe();le();return r}},kill_text:function(){return b},position:function(n,i){if(typeof n==="number"){if(i){_+=n}else if(n<0){_=0}else if(n>v.length){_=v.length}else{_=n}if(e.isFunction(t.onPositionChange)){t.onPositionChange(_)}le();Q();return r}else{return _}},visible:function(){var e=r.visible;return function(){e.apply(r,[]);le();fe()}}(),show:function(){var e=r.show;return function(){e.apply(r,[]);le();fe()}}(),resize:function(e){if(e){s=e}else{ie()}le();fe();return r},enable:function(){if(!x){x=true;r.addClass("enabled");try{a.caret(_)}catch(e){}S(true);fe()}X();return r},isenabled:function(){return x},disable:function(e){x=false;r.removeClass("enabled");S(false);if(!e){X()}return r},mask:function(e){if(typeof e==="undefined"){return d}else{d=e;le();return r}}});r.name(t.name||t.prompt||"");if(typeof t.prompt==="string"){k=t.prompt}else{k="> "}fe();if(t.enabled===n||t.enabled===true){r.enable()}if(!t.history){C.disable()}var pe=true;var me=false;var de=false;var he=false;var ve=false;var ge=false;var ye=true;var we=false;var be=false;var _e;var ke="";function xe(i){Re('keydown "'+i.key+'" '+i.fake);be=(i.key||"").toLowerCase()==="process";var o;de=ve&&he;try{if(!i.fake){he=i.key&&i.key.length===1&&!i.ctrlKey;ge=String(i.key).toLowerCase()==="unidentified";we=i.key.toUpperCase()==="BACKSPACE"||i.which===8}}catch(e){}if(i.key==="Unidentified"){ye=true;return}if(!i.fake){ve=true;ye=false}var a=O(i);if(e.isFunction(t.keydown)){o=t.keydown(i);if(o!==n){if(!o){_e=true}return o}}if(x){_e=["CTRL+V","META+V"].indexOf(a)!==-1;if(i.which!==38&&!(i.which===80&&i.ctrlKey)){pe=true}if(c&&(i.which===35||i.which===36||i.which===37||i.which===38||i.which===39||i.which===40||i.which===13||i.which===27)){te();fe();if(i.which===27){r.set("")}le();xe.call(this,i)}else if(e.isFunction(z[a])){o=z[a]();if(o===true){return}if(o!==n){return o}}else if(i.altKey){return}else{me=false;return}}}var Te=e(document.documentElement||window);r.keymap(t.keymap||{});function Ee(i){Re('keypress "'+i.key+'" '+i.fake);var o;if(!i.fake){ve=false}if((i.ctrlKey||i.metaKey)&&!i.altKey){return}if(me){return}if(e.isFunction(t.keypress)){o=t.keypress(i);if(o!==n){if(!o){_e=true}return o}}if(x){if(i.fake){return}var a;if(W()||i.fake){a=i.key}if(!a||ge){a=String.fromCharCode(i.which)}if(a.toUpperCase()==="SPACEBAR"){a=" "}if(e.inArray(i.which,[13,0,8])>-1){if(i.keyCode===123){return}return false}else if(a&&(!i.ctrlKey||i.ctrlKey&&i.ctrlKey)&&(!(i.altKey&&i.which===100)||i.altKey)&&!de){if(c){u+=a;re();ne()}else{r.insert(a)}}}}function Ce(n,t,r){var i=e.Event(n);i.which=r;i.key=t;i.fake=true;Te.trigger(i)}function Re(e){if(false){console.log(e)}}function Se(){Re("input "+ye+" || "+be+" (("+ve+" || "+de+") && !"+_e+" && ("+he+" || "+ge+") && !"+we+")");if(ye||be||(ve||de)&&!_e&&(he||ge)&&!we){var e=_;var n=a.val();if(ye){we=ke.substring(0,ke.length-1)===ke.length}if(c){u=n;re();ne()}else{var t=n.substring(_);if(t.length===1||we){if(ye){var i;if(we){i=8}else{i=t.toUpperCase().charCodeAt(0)}Ce("keydown",we?"Backspace":t,i)}if(ve&&!we){Ce("keypress",t,t.charCodeAt(0))}}if(we){ke=v;return}if(_e){_e=false;return}r.set(n)}if(we){r.position(e-1)}else{r.position(e+Math.abs(n.length-ke.length))}}ke=v;_e=false;ye=true}Te.bind("keypress.cmd",Ee).bind("keydown.cmd",xe).bind("input.cmd",Se);(function(){var n=false;var i=0;r.on("mousedown.cmd",function(){n=true}).on("mouseup.cmd",function(a){if(M()===""){var s="click_"+o;if(++i===1){var l=n;if(x){r.oneTime(t.clickTimeout,s,function(){if(!e(a.target).is(".prompt")&&l){if(e(a.target).is(".cmd")){r.position(v.length)}else{r.position(j(a))}}i=0})}else{i=0}}else{r.stopTime(s);i=0}}n=false})})();r.data("cmd",r);if(!("KeyboardEvent"in window&&"key"in window.KeyboardEvent.prototype)){setTimeout(function(){throw new Error("key event property not supported try "+"https://github.com/cvan/keyboardevent-key-polyfill")},0)}return r};var b=/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino|android|ipad|playbook|silk/i;var _=/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i;var k=/(\[\[[!gbiuso]*;[^;]*;[^\]]*\](?:[^\]]*\\\][^\]]*|[^\]]*|[^[]*\[[^\]]*)\]?)/i;var x=/\[\[([!gbiuso]*);([^;]*);([^;\]]*);?([^;\]]*);?([^\]]*)\]([^\]]*\\\][^\]]*|[^\]]*|[^[]*\[[^\]]*)\]?/gi;var T=/\[\[([!gbiuso]*;[^;\]]*;[^;\]]*(?:;|[^\]()]*);?[^\]]*)\]([^\]]*\\\][^\]]*|[^\]]*|[^[]*\[[^\]]*)\]?/gi;var E=/\[\[([!gbiuso]*;[^;\]]*;[^;\]]*(?:;|[^\]()]*);?[^\]]*)\]([^\]]*\\\][^\]]*|[^\]]*|[^[]*\[[^\]]*)\]/gi;var C=/^\[\[([!gbiuso]*;[^;\]]*;[^;\]]*(?:;|[^\]()]*);?[^\]]*)\]([^\]]*\\\][^\]]*|[^\]]*|[^[]*\[[^\]]*)\]$/gi;var R=/^#([0-9a-f]{3}|[0-9a-f]{6})$/i;var S=/(\bhttps?:\/\/(?:(?:(?!&[^;]+;)|(?=&amp;))[^\s"'<>\][)])+\b)/gi;var A=/\b(https?:\/\/(?:(?:(?!&[^;]+;)|(?=&amp;))[^\s"'<>\][)])+)\b(?![^[\]]*])/gi;var F=/((([^<>('")[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,})))/g;var L=/((?:"[^"\\]*(?:\\[\S\s][^"\\]*)*"|'[^'\\]*(?:\\[\S\s][^'\\]*)*'|\/[^\/\\]*(?:\\[\S\s][^\/\\]*)*\/[gimy]*(?=\s|$)|(?:\\\s|\S))+)(?=\s|$)/gi;var j=/(\[\[[!gbiuso]*;[^;]*;[^\]]*\])/i;var O=/^(\[\[[!gbiuso]*;[^;]*;[^\]]*\])/i;var z=/\[\[[!gbiuso]*;[^;]*;[^\]]*\]?$/i;var P=/(\[\[(?:[^\]]|\\\])+\]\])/;var I=/^[-+]?[0-9]*\.?[0-9]+([eE][-+]?[0-9]+)?$/;var N=/^\/((?:\\\/|[^/]|\[[^\]]*\/[^\]]*\])+)\/([gimy]*)$/;var $=/^(?=((?:[^"']+|"[^"\\]*(?:\\[^][^"\\]*)*"|'[^'\\]*(?:\\[^][^'\\]*)*')*))\1./;var H=function(){var e=false,t="Webkit Moz O ms Khtml".split(" "),r=document.createElement("div");if(r.style.animationName){e=true}if(e===false){for(var i=0;i<t.length;i++){var o=t[i]+"AnimationName";if(r.style[o]!==n){e=true;break}}}return e}();var q=navigator.userAgent.toLowerCase().indexOf("android")!==-1;var D=function(){if(typeof wcwidth==="undefined"){return function(e){return e.length}}else{return wcwidth}}();var B=function(e){var n=false;if(b.test(e)||_.test(e.substr(0,4))){n=true}return n}(navigator.userAgent||navigator.vendor||window.opera);var M=function(){if(window.getSelection||document.getSelection){return function(){var e=(window.getSelection||document.getSelection)();if(e.text){return e.text}else{return e.toString()}}}else if(document.selection&&document.selection.type!=="Control"){return function(){return document.selection.createRange().text}}return function(){return""}}();function U(n,t){var r=n.match(L)||[];if(r.length){var i=r.shift();var o=e.map(r,t);var a=e.map(r,function(e){var n=e.match(/^(['"]).*\1$/);return n&&n[1]||""});var s=n.substring(i.length).trim();return{command:n,name:i,args:o,args_quotes:a,rest:s}}else{return{command:n,name:"",args:[],args_quotes:a,rest:""}}}e.terminal={version:"1.7.2",color_names:["transparent","currentcolor","black","silver","gray","white","maroon","red","purple","fuchsia","green","lime","olive","yellow","navy","blue","teal","aqua","aliceblue","antiquewhite","aqua","aquamarine","azure","beige","bisque","black","blanchedalmond","blue","blueviolet","brown","burlywood","cadetblue","chartreuse","chocolate","coral","cornflowerblue","cornsilk","crimson","cyan","darkblue","darkcyan","darkgoldenrod","darkgray","darkgreen","darkgrey","darkkhaki","darkmagenta","darkolivegreen","darkorange","darkorchid","darkred","darksalmon","darkseagreen","darkslateblue","darkslategray","darkslategrey","darkturquoise","darkviolet","deeppink","deepskyblue","dimgray","dimgrey","dodgerblue","firebrick","floralwhite","forestgreen","fuchsia","gainsboro","ghostwhite","gold","goldenrod","gray","green","greenyellow","grey","honeydew","hotpink","indianred","indigo","ivory","khaki","lavender","lavenderblush","lawngreen","lemonchiffon","lightblue","lightcoral","lightcyan","lightgoldenrodyellow","lightgray","lightgreen","lightgrey","lightpink","lightsalmon","lightseagreen","lightskyblue","lightslategray","lightslategrey","lightsteelblue","lightyellow","lime","limegreen","linen","magenta","maroon","mediumaquamarine","mediumblue","mediumorchid","mediumpurple","mediumseagreen","mediumslateblue","mediumspringgreen","mediumturquoise","mediumvioletred","midnightblue","mintcream","mistyrose","moccasin","navajowhite","navy","oldlace","olive","olivedrab","orange","orangered","orchid","palegoldenrod","palegreen","paleturquoise","palevioletred","papayawhip","peachpuff","peru","pink","plum","powderblue","purple","red","rosybrown","royalblue","saddlebrown","salmon","sandybrown","seagreen","seashell","sienna","silver","skyblue","slateblue","slategray","slategrey","snow","springgreen","steelblue","tan","teal","thistle","tomato","turquoise","violet","wheat","white","whitesmoke","yellow","yellowgreen"],Cycle:v,History:y,Stack:g,valid_color:function n(t){if(t.match(R)){return true}else{return e.inArray(t.toLowerCase(),e.terminal.color_names)!==-1}},unclosed_strings:function e(n){return!!n.match($)},escape_regex:function e(n){if(typeof n==="string"){var t=/([-\\^$[\]()+{}?*.|])/g;return n.replace(t,"\\$1")}},have_formatting:function e(n){return typeof n==="string"&&!!n.match(E)},is_formatting:function e(n){return typeof n==="string"&&!!n.match(C)},format_split:function e(n){return n.split(k).filter(Boolean)},iterate_formatting:function e(t,r){function i(){return t.substring(u-6,u)==="&nbsp;"||t.substring(u-1,u)===" "}function o(e){return t.substring(e).match(/^(&[^;]+;)/)}var a=false;var s=false;var l=0;var f;var c=-1;for(var u=0;u<t.length;u++){f=t.substring(u).match(O);if(f){a=f[1];s=false}else if(a){if(t[u]==="]"){if(s){a="";s=false}else{s=true}}}else{s=true}var p=a&&s||!a;var m=t[u]==="["&&t[u+1]==="[";if(i()&&(p||m)){c=u}var d=t[u].match(/[[\]]/);if(p){if(t[u]==="&"){f=o(u);if(f){u+=f[1].length-2;continue}++l}else if(t[u]==="]"&&t[u-1]==="\\"){--l}else if(!d){++l}}if(!d&&p){if(D(t[u])===2){l++}var h={count:l,index:u,formatting:a,text:s,space:c};var v=r(h);if(v===false){break}else if(v){if(v.count!==n){l=v.count}if(v.space!==n){c=v.space}if(v.index!==n){u=v.index}}}}},substring:function n(t,r,i){var o=e("<span>"+e.terminal.strip(t)+"</span>").text();if(o.substring(r,i)===""){return""}var a;var s=t.length;var l="";var f="";e.terminal.iterate_formatting(t,function(e){if(e.count===r){a=e.index+1;if(e.formatting){l=e.formatting}}if(i&&e.count===i){s=e.index+1;f=e.formatting}});t=l+t.substring(a,s);if(f){t+="]"}return t},normalize:function e(n){return n.replace(T,function(e,n,t){if(t===""){return""}var r=n.match(/;/g).length;if(r>=4){var i=n.split(/;/);var o=i.slice(0,4).join(";");var a=i.slice(4).join(";");return"[["+o+";"+(a||t)+"]"+t+"]"}else if(r===2){r=";;"}else if(r===3){r=";"}else{r=""}var s=t.replace(/\\\]/g,"&#93;").replace(/\n/g,"\\n").replace(/&nbsp;/g," ");return"[["+n+r+s+"]"+t+"]"})},split_equal:function n(t,r,i){var o="";var a=[];var s=e.terminal.normalize(t).split(/\n/g);for(var l=0,f=s.length;l<f;++l){if(s[l]===""){a.push("");continue}var c=s[l];var u=0;var p;var m=c.length;e.terminal.iterate_formatting(c,function(n){var t=n.index===m-2&&c[n.index+1]==="]";var s=n.index===m-1||t;if(n.count>=r||s||n.count===r-1&&D(c[n.index+1])===2){if(i){var l=e.terminal.strip(c.substring(n.space));l=e("<span>"+l+"</span>").text();var f=l.length;var d=n.index+r+1;l=l.substring(0,d);var h=false;if(l.match(/\s/)||d>f){h=true}}if(i&&!t&&n.space!==-1&&n.index!==m-1&&h){p=c.substring(u,n.space);var v=n.space-1}else{p=c.substring(u,n.index+1)}if(i){p=p.replace(/(&nbsp;|\s)+$/g,"")}u=(v||n.index)+1;if(o){var g=p.match(/^[^\]]*\]/);p=o+p;if(g){o=""}}if(t){p+="]";o=""}var y=p.match(T);if(y){var w=y[y.length-1];if(w[w.length-1]!=="]"){o=w.match(j)[1];p+="]"}else if(p.match(z)){p=p.replace(z,"");o=w.match(j)[1]}}a.push(p);return{index:v,count:0,space:-1}}})}return a},amp:function(e){return e.replace(/&(?!#[0-9]+;|[a-zA-Z]+;)/g,"&amp;")},encode:function n(t){return e.terminal.amp(t).replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/ /g,"&nbsp;").replace(/\t/g,"&nbsp;&nbsp;&nbsp;&nbsp;")},nested_formatting:function n(t){if(!e.terminal.have_formatting(t)){return t}var r=[];var i=/(\[\[(?:[^\]]|\\\])+\](?:[^\][]|\\\])*\]?)/;var o=/(\[\[(?:[^\]]|\\\])+\])[\s\S]*/;return t.split(i).filter(Boolean).map(function(n){if(n.match(/^\[\[/)){if(!e.terminal.is_formatting(n)){n+="]";r.push(n.replace(o,"$1"))}}else{var t=false;if(n.match(/\]/)){t=true}if(r.length){n=r[r.length-1]+n}if(t){r.pop()}else if(r.length){n+="]"}}return n}).join("")},escape_formatting:function n(t){return e.terminal.escape_brackets(t)},apply_formatters:function(n){var t=e.terminal.defaults.formatters;return e.terminal.format_split(n).map(function(n){if(e.terminal.is_formatting(n)){return n}else{for(var r=0;r<t.length;++r){try{if(typeof t[r]==="function"){var i=t[r](n);if(typeof i==="string"){n=i}}}catch(e){throw new Error("Error in formatter ["+r+"]")}}return n}}).join("")},format:function n(t,r){var i=e.extend({},{linksNoReferrer:false},r||{});if(typeof t==="string"){var o=e.terminal.format_split(t);t=e.map(o,function(n){if(n===""){return n}else if(e.terminal.is_formatting(n)){n=n.replace(/\[\[[^\]]+\]/,function(e){return e.replace(/&nbsp;/g," ")});return n.replace(x,function(n,t,r,o,a,s,l){if(l===""){return""}l=l.replace(/\\]/g,"]");var f="";if(t.indexOf("b")!==-1){f+="font-weight:bold;"}var c=[];if(t.indexOf("u")!==-1){c.push("underline")}if(t.indexOf("s")!==-1){c.push("line-through")}if(t.indexOf("o")!==-1){c.push("overline")}if(c.length){f+="text-decoration:"+c.join(" ")+";"}if(t.indexOf("i")!==-1){f+="font-style:italic;"}if(e.terminal.valid_color(r)){f+="color:"+r+";";if(t.indexOf("g")!==-1){f+="text-shadow:0 0 5px "+r+";"}}if(e.terminal.valid_color(o)){f+="background-color:"+o}var u;if(s===""){u=l}else{u=s.replace(/&#93;/g,"]")}var p;if(t.indexOf("!")!==-1){if(u.match(F)){p='<a href="mailto:'+u+'"'}else{p='<a target="_blank" href="'+u+'"';if(i.linksNoReferrer){p+=' rel="noreferrer noopener"'}else{p+=' rel="noopener"'}}p+=' tabindex="1000"'}else{p="<span"}if(f!==""){p+=' style="'+f+'"'}if(a!==""){p+=' class="'+a+'"'}if(t.indexOf("!")!==-1){p+=">"+l+"</a>"}else{p+=' data-text="'+u.replace('"',"&quote;")+'">'+l+"</span>"}return p})}else{return"<span>"+n.replace(/\\\]/g,"]")+"</span>"}}).join("");return t.replace(/<span><br\s*\/?><\/span>/gi,"<br/>")}else{return""}},escape_brackets:function e(n){return n.replace(/\[/g,"&#91;").replace(/\]/g,"&#93;")},strip:function e(n){n=n.replace(x,"$6");return n.replace(/(\\?)([[\]])/g,function(e,n){if(n){return e}else{return""}})},active:function e(){return le.front()},last_id:function e(){var n=le.length();if(n){return n-1}},parse_argument:function e(n,t){function r(e){if(e.match(/^['"]/)){var n=e[0];var t=new RegExp("((^|[^\\\\])(?:\\\\\\\\)*)"+n,"g");e=e.replace(t,"$1")}return JSON.parse('"'+e+'"')}if(t===false){if(n[0]==="'"&&n[n.length-1]==="'"){return n.replace(/^'|'$/g,"")}else if(n[0]==='"'&&n[n.length-1]==='"'){return n.replace(/^"|"$/g,"").replace(/\\([" ])/g,"$1")}else if(n.match(/\/.*\/[gimy]*$/)){return n}else if(n.match(/['"]]/)){return r(n)}else{return n.replace(/\\ /g," ")}}var i=n.match(N);if(i){return new RegExp(i[1],i[2])}else if(n.match(/['"]/)){return r(n)}else if(n.match(/^-?[0-9]+$/)){return parseInt(n,10)}else if(n.match(I)){return parseFloat(n)}else{return n.replace(/\\(['"() ])/g,"$1")}},parse_arguments:function n(t){return e.map(t.match(L)||[],e.terminal.parse_argument)},split_arguments:function(n){return e.map(n.match(L)||[],function(n){return e.terminal.parse_argument(n,false)})},parse_command:function n(t){return U(t,e.terminal.parse_argument)},split_command:function(n){return U(n,function(n){return e.terminal.parse_argument(n,false)})},extended_command:function e(n,t){try{ue=false;n.exec(t,true).done(function(){ue=true})}catch(e){}}};e.fn.visible=function(){return this.css("visibility","visible")};e.fn.hidden=function(){return this.css("visibility","hidden")};e.fn.scroll_element=function(){var n=e.fn.scroll_element.defaults;return this.map(function(){var t=e(this);if(t.is("body")){var r=e("html");var i=e("body");var o=i.scrollTop()||r.scrollTop();var a=e("<pre/>").css(n.pre).appendTo("body");a.html(new Array(n.lines).join("\n"));e("body,html").scrollTop(10);var s;if(i.scrollTop()===10){i.scrollTop(o);s=i[0]}else if(r.scrollTop()===10){r.scrollTop(o);s=r[0]}a.remove();return s}else{return this}})};e.fn.scroll_element.defaults={lines:2e3,pre:{"font-size":"100px","white-space":"pre"}};function W(){if(!("KeyboardEvent"in window&&"key"in window.KeyboardEvent.prototype)){return false}var e=window.KeyboardEvent.prototype;var n=Object.getOwnPropertyDescriptor(e,"key").get;return n.toString().match(/\[native code\]/)}function K(e){e="[jQuery Terminal] "+e;if(console&&console.warn){console.warn(e)}else{setTimeout(function(){throw new Error("WARN: "+e)},0)}}var J={};e.jrpc=function(n,t,r,i,o){var a;if(e.isPlainObject(n)){a=n}else{a={url:n,method:t,params:r,success:i,error:o}}function s(n){return e.isNumeric(n.id)&&(typeof n.result!=="undefined"||typeof n.error!=="undefined")}J[a.url]=J[a.url]||0;var l={jsonrpc:"2.0",method:a.method,params:a.params,id:++J[a.url]};return e.ajax({url:a.url,beforeSend:function n(t,r){if(e.isFunction(a.request)){a.request(t,l)}r.data=JSON.stringify(l)},success:function n(t,r,i){var o=i.getResponseHeader("Content-Type");if(!o.match(/(application|text)\/json/)){K("Response Content-Type is neither application/json"+" nor text/json")}var l;try{l=JSON.parse(t)}catch(e){if(a.error){a.error(i,"Invalid JSON",e)}else{throw new Error("Invalid JSON")}return}if(e.isFunction(a.response)){a.response(i,l)}if(s(l)||a.method==="system.describe"){a.success(l,r,i)}else if(a.error){a.error(i,"Invalid JSON-RPC")}else{throw new Error("Invalid JSON-RPC")}},error:a.error,contentType:"application/json",dataType:"text",async:true,cache:false,type:"POST"})};function Y(){var n=e('<div class="terminal temp"><div class="cmd"><span cla'+'ss="prompt">&nbsp;</span></div></div>').appendTo("body");var t=n.find("span")[0].getBoundingClientRect();var r={width:t.width,height:t.height};n.remove();return r}function G(e,n){var t=e.find(".terminal-fill").width();var r=Math.floor(t/n.width);return r||1e3}function X(e,n){return Math.floor(e.find(".terminal-fill").height()/n.height)}function V(n,t){var r=e("<div>"+t.replace(/\n/,"<br/>")+"<div>");var i;n.append(r);if(document.body.createTextRange){i=document.body.createTextRange();i.moveToElementText(r[0]);i.select()}else if(window.getSelection){var o=window.getSelection();if(o.setBaseAndExtent){o.setBaseAndExtent(r[0],0,r[0],1)}else if(document.createRange){i=document.createRange();i.selectNodeContents(r[0]);o.removeAllRanges();o.addRange(i)}}try{document.execCommand("copy")}catch(e){}r.remove()}function Q(e,n){var t=e.filter(function(e){return e[n]()===e});return t.length===e.length}function Z(e){var n=e.split("");if(Q(n,"toLowerCase")){return"lower"}else if(Q(n,"toUpperCase")){return"upper"}else{return"mixed"}}function ee(e){return Z(e)!=="mixed"}var ne=!e.terminal.version.match(/^\{\{/);var te="Copyright (c) 2011-2017 Jakub Jankiewicz <http://jcubic"+".pl/me>";var re=ne?" v. "+e.terminal.version:" ";var ie=new RegExp(" {"+re.length+"}$");var oe="jQuery Terminal Emulator"+(ne?re:"");var ae=[["jQuery Terminal","(c) 2011-2017 jcubic"],[oe,te.replace(/^Copyright | *<.*>/g,"")],[oe,te.replace(/^Copyright /,"")],["      _______                 ________                        __","     / / _  /_ ____________ _/__  ___/______________  _____  / /"," __ / / // / // / _  / _/ // / / / _  / _/     / /  \\/ / _ \\/ /","/  / / // / // / ___/ // // / / / ___/ // / / / / /\\  / // / /__","\\___/____ \\\\__/____/_/ \\__ / /_/____/_//_/_/_/ /_/  \\/\\__\\_\\___/","         \\/          /____/                                   ".replace(ie," ")+re,te],["      __ _____                     ________                            "+"  __","     / // _  /__ __ _____ ___ __ _/__  ___/__ ___ ______ __ __  __ ___ "+" / /"," __ / // // // // // _  // _// // / / // _  // _//     // //  \\/ // _ "+"\\/ /","/  / // // // // // ___// / / // / / // ___// / / / / // // /\\  // // "+"/ /__","\\___//____ \\\\___//____//_/ _\\_  / /_//____//_/ /_/ /_//_//_/ /_/ \\"+"__\\_\\___/",("          \\/              /____/                                      "+"    ").replace(ie,"")+re,te]];e.terminal.defaults={prompt:"> ",history:true,exit:true,clear:true,enabled:true,maskChar:"*",wrap:true,checkArity:true,raw:false,exceptionHandler:null,pauseEvents:true,softPause:false,memory:false,cancelableAjax:true,processArguments:true,linksNoReferrer:false,processRPCResponse:null,completionEscape:true,convertLinks:true,extra:{},historySize:60,historyState:false,importHistory:false,historyFilter:null,echoCommand:true,scrollOnEcho:true,login:null,outputLimit:-1,formatters:[e.terminal.nested_formatting],onAjaxError:null,scrollBottomOffset:20,wordAutocomplete:true,caseSensitiveAutocomplete:true,clickTimeout:200,request:e.noop,response:e.noop,describe:"procs",onRPCError:null,completion:false,onInit:e.noop,onClear:e.noop,onBlur:e.noop,onFocus:e.noop,onTerminalChange:e.noop,onExit:e.noop,onPush:e.noop,onPop:e.noop,keypress:e.noop,keydown:e.noop,onAfterRedraw:e.noop,onEchoCommand:e.noop,strings:{comletionParameters:"From version 1.0.0 completion function need to"+" have two arguments",wrongPasswordTryAgain:"Wrong password try again!",wrongPassword:"Wrong password!",ajaxAbortError:"Error while aborting ajax call!",wrongArity:"Wrong number of arguments. Function '%s' expects %s got"+" %s!",commandNotFound:"Command '%s' Not Found!",oneRPCWithIgnore:"You can use only one rpc with describe == false "+"or rpc without system.describe",oneInterpreterFunction:"You can't use more than one function (rpc "+"without system.describe or with option describe == false count"+"s as one)",loginFunctionMissing:"You didn't specify a login function",noTokenError:"Access denied (no token)",serverResponse:"Server responded",wrongGreetings:"Wrong value of greetings parameter",notWhileLogin:"You can't call `%s' function while in login",loginIsNotAFunction:"Authenticate must be a function",canExitError:"You can't exit from main interpreter",invalidCompletion:"Invalid completion",invalidSelector:'Sorry, but terminal said that "%s" is not valid '+"selector!",invalidTerminalId:"Invalid Terminal ID",login:"login",password:"password",recursiveCall:"Recursive call detected, skip",notAString:"%s function: argument is not a string",redrawError:"Internal error, wrong position in cmd redraw",invalidStrings:"Command %s have unclosed strings"}};var se=[];var le=new v;var fe=[];var ce;var ue=false;var pe=true;var me=true;e.fn.terminal=function(r,o){function a(n){if(n){this.storage={}}this.set=function(t,r){if(n){this.storage[t]=r}else{e.Storage.set(t,r)}};this.get=function(t){if(n){return this.storage[t]}else{return e.Storage.get(t)}};this.remove=function(t){if(n){delete this.storage[t]}else{e.Storage.remove(t)}}}function s(n){if(e.terminal.unclosed_strings(n)){var t=e.terminal.escape_brackets(n);throw new Error(sprintf(he().invalidStrings,"`"+t+"`"))}else if(e.isFunction(Ne.processArguments)){return U(n,Ne.processArguments)}else if(Ne.processArguments){return e.terminal.parse_command(n)}else{return e.terminal.split_command(n)}}function l(n){if(typeof n==="string"){ve.echo(n)}else if(n instanceof Array){ve.echo(e.map(n,function(e){return JSON.stringify(e)}).join(" "))}else if(typeof n==="object"){ve.echo(JSON.stringify(n))}else{ve.echo(n)}}function f(n){var t=/(.*):([0-9]+):([0-9]+)$/;var r=n.match(t);if(r){ve.pause(Ne.softPause);e.get(r[1],function(n){var t=location.href.replace(/[^/]+$/,"");var i=r[1].replace(t,"");ve.echo("[[b;white;]"+i+"]");var o=n.split("\n");var a=+r[2]-1;ve.echo(o.slice(a-2,a+3).map(function(n,t){if(t===2){n="[[;#f00;]"+e.terminal.escape_brackets(n)+"]"}return"["+(a+t)+"]: "+n}).join("\n")).resume()},"text")}}function c(n){if(e.isFunction(Ne.onRPCError)){Ne.onRPCError.call(ve,n)}else{ve.error("&#91;RPC&#93; "+n.message);if(n.error&&n.error.message){n=n.error;var t="\t"+n.message;if(n.file){t+=' in file "'+n.file.replace(/.*\//,"")+'"'}if(n.at){t+=" at line "+n.at}ve.error(t)}}}function u(n,t){var r=function(t,r){ve.pause(Ne.softPause);e.jrpc({url:n,method:t,params:r,request:function(e,n){try{Ne.request.apply(ve,e,n,ve)}catch(e){b(e,"USER")}},response:function(e,n){try{Ne.response.apply(ve,e,n,ve)}catch(e){b(e,"USER")}},success:function n(t){if(t.error){c(t.error)}else if(e.isFunction(Ne.processRPCResponse)){Ne.processRPCResponse.call(ve,t.result,ve)}else{l(t.result)}ve.resume()},error:m})};return function(e,n){if(e===""){return}try{e=s(e)}catch(e){b(e,"TERMINAL (get_processed_command)");return}if(!t||e.name==="help"){r(e.name,e.args)}else{var i=n.token();if(i){r(e.name,[i].concat(e.args))}else{n.error("&#91;AUTH&#93; "+he().noTokenError)}}}}function p(t,r,i,o){return function(a,l){if(a===""){return}var f;try{f=s(a)}catch(n){if(e.isFunction(Ne.exception)){Ne.exception(n,ve)}else{ve.error(n.toString())}return}var c=t[f.name];var u=e.type(c);if(u==="function"){if(r&&c.length!==f.args.length){ve.error("&#91;Arity&#93; "+sprintf(he().wrongArity,f.name,c.length,f.args.length))}else{return c.apply(ve,f.args)}}else if(u==="object"||u==="string"){var m=[];if(u==="object"){m=Object.keys(c);c=p(c,r,i)}l.push(c,{prompt:f.name+"> ",name:f.name,completion:u==="object"?m:n})}else if(e.isFunction(o)){o(a,ve)}else if(e.isFunction(Ne.onCommandNotFound)){Ne.onCommandNotFound.call(ve,a,ve)}else{l.error(sprintf(he().commandNotFound,f.name))}}}function m(n,t,r){ve.resume();if(e.isFunction(Ne.onAjaxError)){Ne.onAjaxError.call(ve,n,t,r)}else if(t!=="abort"){ve.error("&#91;AJAX&#93; "+t+" - "+he().serverResponse+":\n"+e.terminal.escape_brackets(n.responseText))}}function d(n,t,r){function i(n){if(n.error){c(n.error)}else if(e.isFunction(Ne.processRPCResponse)){Ne.processRPCResponse.call(ve,n.result,ve)}else{l(n.result)}ve.resume()}function o(e,n){try{Ne.request.call(ve,e,n,ve)}catch(e){b(e,"USER")}}function a(e,n){try{Ne.response.call(ve,e,n,ve)}catch(e){b(e,"USER")}}function s(s){var l=s;if(Ne.describe!==""){Ne.describe.split(".").forEach(function(e){l=l[e]})}if(l&&l.length){var f={};e.each(l,function(r,s){f[s.name]=function(){var r=t&&s.name!=="help";var l=Array.prototype.slice.call(arguments);var f=l.length+(r?1:0);if(Ne.checkArity&&s.params&&s.params.length!==f){ve.error("&#91;Arity&#93; "+sprintf(he().wrongArity,s.name,s.params.length,f))}else{ve.pause(Ne.softPause);if(r){var c=ve.token(true);if(c){l=[c].concat(l)}else{ve.error("&#91;AUTH&#93; "+he().noTokenError)}}e.jrpc({url:n,method:s.name,params:l,request:o,response:a,success:i,error:m})}}});f.help=f.help||function(n){if(typeof n==="undefined"){var t=s.procs.map(function(e){return e.name}).join(", ")+", help";ve.echo("Available commands: "+t)}else{var r=false;e.each(l,function(e,t){if(t.name===n){r=true;var i="";i+="[[bu;#fff;]"+t.name+"]";if(t.params){i+=" "+t.params.join(" ")}if(t.help){i+="\n"+t.help}ve.echo(i);return false}});if(!r){if(n==="help"){ve.echo("[[bu;#fff;]help] [method]\ndisplay help "+"for the method or list of methods if not"+" specified")}else{var i="Method `"+n+"' not found ";ve.error(i)}}}};r(f)}else{r(null)}}return e.jrpc({url:n,method:"system.describe",params:[],success:s,request:o,response:a,error:function e(){r(null)}})}function v(n,t,r){r=r||e.noop;var i=e.type(n);var o;var a={};var s=0;var l;if(i==="array"){o={};(function n(r,i){if(r.length){var a=r[0];var f=r.slice(1);var c=e.type(a);if(c==="string"){ve.pause(Ne.softPause);if(Ne.describe===false){if(++s===1){l=u(a,t)}else{ve.error(he().oneRPCWithIgnore)}n(f,i)}else{d(a,t,function(r){if(r){e.extend(o,r)}else if(++s===1){l=u(a,t)}else{ve.error(he().oneRPCWithIgnore)}ve.resume();n(f,i)})}}else if(c==="function"){if(l){ve.error(he().oneInterpreterFunction)}else{l=a}n(f,i)}else if(c==="object"){e.extend(o,a);n(f,i)}}else{i()}})(n,function(){r({interpreter:p(o,false,t,l.bind(ve)),completion:Object.keys(o)})})}else if(i==="string"){if(Ne.ignoreSystemDescribe){o={interpreter:u(n,t)};if(e.isArray(Ne.completion)){o.completion=Ne.completion}r(o)}else{ve.pause(Ne.softPause);d(n,t,function(e){if(e){a.interpreter=p(e,false,t);a.completion=Object.keys(e)}else{a.interpreter=u(n,t)}r(a);ve.resume()})}}else if(i==="object"){r({interpreter:p(n,Ne.checkArity),completion:Object.keys(n)})}else{if(i==="undefined"){n=e.noop}else if(i!=="function"){throw new Error(i+" is invalid interpreter value")}r({interpreter:n,completion:Ne.completion})}}function y(n,t){var r=e.type(t)==="boolean"?"login":t;return function(t,i,o){ve.pause(Ne.softPause);e.jrpc({url:n,method:r,params:[t,i],request:function(e,n){try{Ne.request.call(ve,e,n,ve)}catch(e){b(e,"USER")}},response:function(e,n){try{Ne.response.call(ve,e,n,ve)}catch(e){b(e,"USER")}},success:function e(n){if(!n.error&&n.result){o(n.result)}else{o(null)}ve.resume()},error:m})}}function w(e){if(typeof e==="string"){return e}else if(typeof e.fileName==="string"){return e.fileName+": "+e.message}else{return e.message}}function b(n,t){if(e.isFunction(Ne.exceptionHandler)){Ne.exceptionHandler.call(ve,n,t)}else{ve.exception(n,t)}}function _(){var e;if(ge.prop){e=ge.prop("scrollHeight")}else{e=ge.attr("scrollHeight")}ge.scrollTop(e)}function k(n,t){try{if(e.isFunction(t)){t.call(ve,e.noop,ve)}else if(typeof t!=="string"){var r=n+" must be string or function";throw r}}catch(e){b(e,n.toUpperCase());return false}return true}var x=[];var T=1;function E(t,r){if(Ne.convertLinks&&!r.raw){t=t.replace(F,"[[!;;]$1]").replace(A,"[[!;;]$1]")}var i,o;if(!r.raw){if(r.formatters){try{t=e.terminal.apply_formatters(t)}catch(n){if(e.isFunction(Ne.exceptionHandler)){Ne.exceptionHandler.call(ve,n,"FORMATTERS")}else{alert(n.message+"\n"+(n.stack?n.stack:n))}}}t=e.terminal.encode(t)}x.push(T);if(!r.raw&&(D(t)>xe||t.match(/\n/))&&(Ne.wrap===true&&r.wrap===n||Ne.wrap===false&&r.wrap===true)){var a=r.keepWords;var s=e.terminal.split_equal(t,xe,a);for(i=0,o=s.length;i<o;++i){if(s[i]===""||s[i]==="\r"){x.push("<span></span>")}else if(r.raw){x.push(s[i])}else{x.push(e.terminal.format(s[i],{linksNoReferrer:Ne.linksNoReferrer}))}}}else if(!r.raw){t=e.terminal.normalize(t);t=e.terminal.format(t,{linksNoReferrer:Ne.linksNoReferrer});t.split(/\n/).forEach(function(e){x.push(e)})}else{x.push(t)}x.push(r.finalize)}function C(n,t){try{var r=e.extend({exec:true,raw:false,finalize:e.noop},t||{});var i=e.type(n)==="function"?n():n;i=e.type(i)==="string"?i:String(i);if(i!==""){i=e.map(i.split(P),function(n){if(n&&n.match(P)&&!e.terminal.is_formatting(n)){n=n.replace(/^\[\[|\]\]$/g,"");if(r.exec){if(ye&&ye.command===n){ve.error(he().recursiveCall)}else{e.terminal.extended_command(ve,n)}}return""}else{return n}}).join("");if(i!==""){E(i,r)}}}catch(n){x=[];if(e.isFunction(Ne.exceptionHandler)){Ne.exceptionHandler.call(ve,n,"TERMINAL")}else{alert("[Internal Exception(process_line)]:"+w(n)+"\n"+n.stack)}}}function R(){Ue.resize(xe);var n=_e.empty().detach();var t=[];if(Ne.outputLimit>=0){var r;if(Ne.outputLimit===0){r=ve.rows()}else{r=Ne.outputLimit}be.forEach(function(n){var r=e.type(n[0])==="function"?n[0]():n[0];r=e.type(r)==="string"?r:String(r);if(D(r)>xe){var i=n[1];var o=e.terminal.split_equal(r,xe,i.keepWords);t=t.concat(o.map(function(e){return[e,i]}))}else{t.push(n)}});t=t.slice(t.length-r-1)}else{t=be}try{x=[];e.each(be,function(e,n){C.apply(null,n)});Ue.before(n);ve.flush();Ne.onAfterRedraw.call(ve)}catch(n){if(e.isFunction(Ne.exceptionHandler)){Ne.exceptionHandler.call(ve,n,"TERMINAL (redraw)")}else{alert("Exception in redraw\n"+n.stack)}}}function L(){if(Ne.greetings===n){ve.echo(ve.signature,{finalize:h})}else if(Ne.greetings){var e=typeof Ne.greetings;if(e==="string"){ve.echo(Ne.greetings)}else if(e==="function"){Ne.greetings.call(ve,ve.echo)}else{ve.error(he().wrongGreetings)}}}function j(n){if(typeof n==="undefined"){n=ve.get_command()}var t=Ue.prompt();var r=Ue.mask();switch(typeof r){case"string":n=n.replace(/./g,r);break;case"boolean":if(r){n=n.replace(/./g,Ne.maskChar)}else{n=e.terminal.escape_formatting(n)}break}var i={finalize:function e(n){h(n.addClass("command"));Ne.onEchoCommand.call(ve,n)}};if(e.isFunction(t)){t(function(e){ve.echo(e+n,i)})}else{ve.echo(t+n,i)}}function O(e){var n=le.get()[e[0]];if(!n){throw new Error(he().invalidTerminalId)}var t=e[1];if(fe[t]){n.import_view(fe[t])}else{ue=false;var r=e[2];if(r){n.exec(r).done(function(){ue=true;fe[t]=n.export_view()})}}}function z(){if(ue){pe=false;location.hash="#"+JSON.stringify(ce);setTimeout(function(){pe=true},100)}}var I=true;var N=[];function $(t,r,i){if(I){I=false;if(Ne.historyState||Ne.execHash&&i){if(!fe.length){ve.save_state()}else{ve.save_state(null)}}}function o(){if(!i){ue=true;if(Ne.historyState){ve.save_state(t,false)}ue=c}f.resolve();if(e.isFunction(Ne.onAfterCommand)){Ne.onAfterCommand.call(ve,ve,t)}}function a(e){if(e&&p===be.length-1){l(e)}o();ve.resume()}try{if(e.isFunction(Ne.onBeforeCommand)){if(Ne.onBeforeCommand.call(ve,ve,t)===false){return}}if(!i){ye=e.terminal.split_command(t)}if(!ne()){if(i&&(e.isFunction(Ne.historyFilter)&&Ne.historyFilter(t)||t.match(Ne.historyFilter))){Ue.history().append(t)}}var s=Me.top();if(!r&&Ne.echoCommand){j(t)}var f=new e.Deferred;var c=ue;if(t.match(/^\s*login\s*$/)&&ve.token(true)){if(ve.level()>1){ve.logout(true)}else{ve.logout()}o()}else if(Ne.exit&&t.match(/^\s*exit\s*$/)&&!je){var u=ve.level();if(u===1&&ve.get_token()||u>1){if(ve.get_token(true)){ve.set_token(n,true)}ve.pop()}o()}else if(Ne.clear&&t.match(/^\s*clear\s*$/)&&!je){ve.clear();o()}else{var p=be.length-1;var m=s.interpreter.call(ve,t,ve);if(m!==n){ve.pause(Ne.softPause);if(m.then){m.then(a)}else{return e.when(m).done(a)}}else if(De){N.push(function(){o()})}else{o()}}return f.promise()}catch(e){b(e,"USER");ve.resume();if(!Ne.exceptionHandler){throw e}}}function H(){if(e.isFunction(Ne.onBeforeLogout)){try{if(Ne.onBeforeLogout.call(ve,ve)===false){return}}catch(e){b(e,"onBeforeLogout")}}W();if(e.isFunction(Ne.onAfterLogout)){try{Ne.onAfterLogout.call(ve,ve)}catch(e){b(e,"onAfterlogout")}}ve.login(Ne.login,true,Q)}function W(){var e=ve.prefix_name(true)+"_";$e.remove(e+"token");$e.remove(e+"login")}function K(n){var t=ve.prefix_name()+"_interpreters";var r=$e.get(t);if(r){r=JSON.parse(r)}else{r=[]}if(e.inArray(n,r)===-1){r.push(n);$e.set(t,JSON.stringify(r))}}function J(n){var t=Me.top();var r=ve.prefix_name(true);if(!ne()){K(r)}Ue.name(r);if(e.isFunction(t.prompt)){Ue.prompt(function(e){t.prompt.call(ve,e,ve)})}else{Ue.prompt(t.prompt)}if(e.isPlainObject(t.keymap)){Ue.keymap(e.omap(t.keymap,function(e,n){return function(){var e=[].slice.call(arguments);try{return n.apply(ve,e)}catch(e){b(e,"USER KEYMAP");if(!Ne.exceptionHandler){throw e}}}}))}Ue.set("");Se.resolve();if(!n&&e.isFunction(t.onStart)){t.onStart.call(ve,ve)}}function V(){if(pe&&Ne.execHash){try{if(location.hash){var e=location.hash.replace(/^#/,"");ce=JSON.parse(decodeURIComponent(e))}else{ce=[]}if(ce.length){O(ce[ce.length-1])}else if(fe[0]){ve.import_view(fe[0])}}catch(e){b(e,"TERMINAL")}}}function Q(){J();L();if(be.length){R()}var n=false;if(e.isFunction(Ne.onInit)){Oe=function(){n=true};try{Ne.onInit.call(ve,ve)}catch(e){b(e,"OnInit")}finally{Oe=e.noop;if(!n&&ve.enabled()){ve.resume()}}}if(me){me=false;e(window).on("hashchange",V)}}function ne(){return je||Ue.mask()!==false}function te(e,n,t){if(!n.length){return""}var r=Z(e);var i=[];e:for(var o=e.length;o<n[0].length;++o){for(var a=1;a<n.length;++a){var s=n[0].charAt(o);var l=n[a].charAt(o);if(s!==l){if(t||r==="mixed"){break e}else if(s.toLowerCase()===l.toLowerCase()){if(r==="lower"){i.push(s.toLowerCase())}else{i.push(s.toUpperCase())}}}else{i.push(s)}}}return e+i.join("")}function re(t){var r,i=Me.top();if(e.isFunction(i.keydown)){r=i.keydown.call(ve,t,ve);if(r!==n){return r}}else if(e.isFunction(Ne.keydown)){r=Ne.keydown.call(ve,t,ve);if(r!==n){return r}}}var ie={"CTRL+D":function(e,t){if(!je){if(Ue.get()===""){if(Me.size()>1||Ne.login!==n){ve.pop("")}else{ve.resume();ve.echo("")}}else{t()}}return false},"CTRL+L":function(){ve.clear()},TAB:function(t,r){var i=Me.top(),o,a;if(typeof i.caseSensitiveAutocomplete!=="undefined"){a=i.caseSensitiveAutocomplete}else{a=Ne.caseSensitiveAutocomplete}if(Ne.completion&&e.type(Ne.completion)!=="boolean"&&i.completion===n){o=Ne.completion}else{o=i.completion}if(o==="settings"){o=Ne.completion}if(o){switch(e.type(o)){case"function":var s=ve.before_cursor(Ne.wordAutocomplete);if(o.length===3){var l=new Error(he().comletionParameters);b(l,"USER");return false}o.call(ve,s,function(e){ve.complete(e,{echo:true,word:Ne.wordAutocomplete,escape:Ne.completionEscape,caseSensitive:a})});break;case"array":ve.complete(o,{echo:true,word:Ne.wordAutocomplete,escape:Ne.completionEscape,caseSensitive:a});break;default:throw new Error(he().invalidCompletion)}}else{r()}return false},"CTRL+V":function(e,n){n(e);ve.oneTime(200,function(){_()});return true},"CTRL+TAB":function(){if(le.length()>1){ve.focus(false);return false}},PAGEDOWN:function(){ve.scroll(ve.height())},PAGEUP:function(){ve.scroll(-ve.height())}};function oe(t){var r,i;if(ve.enabled()){if(!ve.paused()){r=re(t);if(r!==n){return r}if(t.which!==9){we=0}ve.attr({scrollTop:ve.attr("scrollHeight")})}else{if(!Ne.pauseEvents){r=re(t);if(r!==n){return r}}if(t.which===68&&t.ctrlKey){if(Ne.pauseEvents){r=re(t);if(r!==n){return r}}if(se.length){for(i=se.length;i--;){var o=se[i];if(o.readyState!==4){try{o.abort()}catch(n){if(e.isFunction(Ne.exceptionHandler)){Ne.exceptionHandler.call(ve,t,"AJAX ABORT")}else{ve.error(he().ajaxAbortError)}}}}se=[]}ve.resume()}return false}}}function de(e){return function(n){e.add(n)}}function he(){return e.extend({},e.terminal.defaults.strings,Ne&&Ne.strings||{})}var ve=this;if(this.length>1){return this.each(function(){e.fn.terminal.call(e(this),r,e.extend({name:ve.selector},o))})}if(ve.data("terminal")){return ve.data("terminal")}if(ve.length===0){throw new Error(sprintf(he().invalidSelector,ve.selector))}var ge;var ye;var we=0;var be=[];var _e;var ke=le.length();var xe;var Te;var Ee;var Ce=new g;var Re=new t;var Se=new t;var Ae=de(Se);var Fe=Y();var Le=de(Re);var je=false;var Oe=e.noop;var ze,Pe;var Ie=[];var Ne=e.extend({},e.terminal.defaults,{name:ve.selector},o||{});var $e=new a(Ne.memory);var He=Ne.enabled,qe=false;var De=false;var Be=true;var Me;var Ue;var We;var Ke;var Je;e.extend(ve,e.omap({id:function(){return ke},clear:function(){_e.html("");be=[];try{Ne.onClear.call(ve,ve)}catch(e){b(e,"onClear")}ve.attr({scrollTop:0});return ve},export_view:function(){var n={};if(e.isFunction(Ne.onExport)){try{n=Ne.onExport.call(ve)}catch(e){b(e,"onExport")}}return e.extend({},{focus:He,mask:Ue.mask(),prompt:ve.get_prompt(),command:ve.get_command(),position:Ue.position(),lines:i(be),interpreters:Me.clone(),history:Ue.history().data},n)},import_view:function(n){if(je){throw new Error(sprintf(he().notWhileLogin,"import_view"))}if(e.isFunction(Ne.onImport)){try{Ne.onImport.call(ve,n)}catch(e){b(e,"onImport")}}Ae(function e(){ve.set_prompt(n.prompt);ve.set_command(n.command);Ue.position(n.position);Ue.mask(n.mask);if(n.focus){ve.focus()}be=i(n.lines);Me=n.interpreters;if(Ne.importHistory){Ue.history().set(n.history)}R()});return ve},save_state:function(t,r,i){if(typeof i!=="undefined"){fe[i]=ve.export_view()}else{fe.push(ve.export_view())}if(!e.isArray(ce)){ce=[]}if(t!==n&&!r){var o=[ke,fe.length-1,t];ce.push(o);z()}},exec:function(n,t,r){var i=r||new e.Deferred;Le(function r(){if(e.isArray(n)){(function e(){var r=n.shift();if(r){ve.exec(r,t).done(e)}else{i.resolve()}})()}else if(De){Ie.push([n,t,i])}else{$(n,t,true).done(function(){i.resolve(ve)})}});return i.promise()},autologin:function(e,n,t){ve.trigger("terminal.autologin",[e,n,t]);return ve},login:function(t,r,i,o){Ce.push([].slice.call(arguments));if(je){throw new Error(sprintf(he().notWhileLogin,"login"))}if(!e.isFunction(t)){throw new Error(he().loginIsNotAFunction)}je=true;if(ve.token()&&ve.level()===1&&!Be){je=false;ve.logout(true)}else if(ve.token(true)&&ve.login_name(true)){je=false;if(e.isFunction(i)){i()}return ve}if(Ne.history){Ue.history().disable()}var a=ve.level();function s(t,s,l){if(s){while(ve.level()>a){ve.pop(n,true)}if(Ne.history){Ue.history().enable()}var f=ve.prefix_name(true)+"_";$e.set(f+"token",s);$e.set(f+"login",t);je=false;if(e.isFunction(i)){i()}}else{if(r){if(!l){ve.error(he().wrongPasswordTryAgain)}ve.pop(n,true).set_mask(false)}else{je=false;if(!l){ve.error(he().wrongPassword)}ve.pop(n,true).pop(n,true)}if(e.isFunction(o)){o()}}ve.off("terminal.autologin")}ve.on("terminal.autologin",function(e,n,t,r){s(n,t,r)});ve.push(function(e){ve.set_mask(Ne.maskChar).push(function(n){try{t.call(ve,e,n,function(n,t){s(e,n,t)})}catch(e){b(e,"AUTH")}},{prompt:he().password+": ",name:"password"})},{prompt:he().login+": ",name:"login"});return ve},settings:function(){return Ne},before_cursor:function(e){var n=Ue.position();var t=Ue.get().substring(0,n);var r=t.split(" ");var i;if(e){if(r.length===1){i=r[0]}else{var o=t.match(/(\\?")/g);var a=o?o.filter(function(e){return!e.match(/^\\/)}).length:0;o=t.match(/'/g);var s=o?o.length:0;if(s%2===1){i=t.match(/('[^']*)$/)[0]}else if(a%2===1){i=t.match(/("(?:[^"]|\\")*)$/)[0]}else{i=r[r.length-1];for(Xe=r.length-1;Xe>0;Xe--){var l=r[Xe-1];if(l[l.length-1]==="\\"){i=r[Xe-1]+" "+i}else{break}}}}}else{i=t}return i},complete:function(n,t){t=e.extend({word:true,echo:false,escape:true,caseSensitive:true},t||{});var r=t.caseSensitive;var i=ve.before_cursor(t.word).replace(/\\"/g,'"');var o=false;if(t.word){if(i.match(/^"/)){o='"'}else if(i.match(/^'/)){o="'"}if(o){i=i.replace(/^["']/,"")}}n=n.slice();if(Ne.clear&&e.inArray("clear",n)===-1){n.push("clear")}if(Ne.exit&&e.inArray("exit",n)===-1){n.push("exit")}if(we%2===0){Ee=ve.before_cursor(t.word)}else{var a=ve.before_cursor(t.word);if(a!==Ee){return}}var s=e.terminal.escape_regex(i);if(t.escape){s=s.replace(/(\\+)(["'() ])/g,function(e,n,t){if(t.match(/[()]/)){return n+"\\?\\"+t}else{return n+"?"+t}})}function l(){var e=[];for(var a=n.length;a--;){if(c.test(n[a])){var s=n[a];if(o==='"'){s=s.replace(/"/g,'\\"')}if(!o&&t.escape){s=s.replace(/(["'() ])/g,"\\$1")}if(!r&&ee(s)){if(i.toLowerCase()===i){s=s.toLowerCase()}else if(i.toUpperCase()===i){s=s.toUpperCase()}}e.push(s)}}return e}var f=r?"":"i";var c=new RegExp("^"+s,f);var u=l();function p(e,n){var t=ve.get_command();var r=ve.get_position();var i=new RegExp(e+"$");var a=t.substring(0,r).replace(i,"");var s=t.substring(r);var l=n+(o||"");ve.set_command(a+l+s);ve.set_position((a+l).length)}if(u.length===1){if(t.escape){p(s,u[0])}else{ve.insert(u[0].replace(c,"")+(o||""))}Ee=ve.before_cursor(t.word);return true}else if(u.length>1){if(++we>=2){we=0;if(t.echo){j();var m=u.reverse().join("\t");ve.echo(e.terminal.escape_brackets(m),{keepWords:true});return true}}else{var d=te(i,u,r);if(d){p(i,d);Ee=ve.before_cursor(t.word);return true}}}},commands:function(){return Me.top().interpreter},set_interpreter:function(n,t){function r(){ve.pause(Ne.softPause);v(n,!!t,function(n){ve.resume();var t=Me.top();e.extend(t,n);J(true)})}if(e.type(n)==="string"&&t){ve.login(y(n,t),true,r)}else{r()}return ve},greetings:function(){L();return ve},paused:function(){return De},pause:function(n){Le(function t(){Oe();De=true;Ue.disable(n||q);if(!n){Ue.find(".prompt").hidden()}if(e.isFunction(Ne.onPause)){Ne.onPause.call(ve)}});return ve},resume:function(){Le(function n(){De=false;if(He&&le.front()===ve){Ue.enable()}Ue.find(".prompt").visible();var t=Ie;Ie=[];for(var r=0;r<t.length;++r){ve.exec.apply(ve,t[r])}ve.trigger("resume");var i=N.shift();if(i){i()}_();if(e.isFunction(Ne.onResume)){Ne.onResume.call(ve)}});return ve},cols:function(){if(Ne.numChars){return Ne.numChars}if(typeof xe==="undefined"){xe=G(ve,Fe)}return xe},rows:function(){if(Ne.numRows){return Ne.numRows}if(typeof Te==="undefined"){Te=X(ve,Fe)}return Te},history:function(){return Ue.history()},history_state:function(e){function n(){Ne.historyState=true;if(!fe.length){ve.save_state()}else if(le.length()>1){ve.save_state(null)}}if(e){if(typeof window.setImmediate==="undefined"){setTimeout(n,0)}else{setImmediate(n)}}else{Ne.historyState=false}return ve},clear_history_state:function(){ce=[];fe=[];return ve},next:function(){if(le.length()===1){return ve}else{le.front().disable();var n=le.rotate().enable();var t=n.offset().top-50;e("html,body").animate({scrollTop:t},500);try{Ne.onTerminalChange.call(n,n)}catch(e){b(e,"onTerminalChange")}return n}},focus:function(e,n){Le(function t(){if(le.length()===1){if(e===false){ve.disable(n)}else{ve.enable(n)}}else if(e===false){ve.next()}else{var r=le.front();if(r!==ve){le.forEach(function(e){if(e!==ve&&e.enabled()){e.disable(n)}});if(!n){try{Ne.onTerminalChange.call(ve,ve)}catch(e){b(e,"onTerminalChange")}}}le.set(ve)}ve.enable(n)});return ve},freeze:function(e){Ae(function n(){if(e){ve.disable();qe=true}else{qe=false;ve.enable()}})},frozen:function(){return qe},enable:function(e){if(!He&&!qe){if(xe===n){ve.resize()}Le(function t(){var r;if(!e&&!He){try{r=Ne.onFocus.call(ve,ve)}catch(e){b(e,"onFocus")}}if(!e&&r===n||e){He=true;if(!ve.paused()){Ue.enable()}}})}return ve},disable:function(e){Le(function t(){var r;if(!e&&He){try{r=Ne.onBlur.call(ve,ve)}catch(e){b(e,"onBlur")}}if(!e&&r===n||e){He=false;Ue.disable()}});return ve},enabled:function(){return He},signature:function(){var e=ve.cols();for(var n=ae.length;n--;){var t=ae[n].map(function(e){return e.length});if(Math.max.apply(null,t)<=e){return ae[n].join("\n")+"\n"}}return""},version:function(){return e.terminal.version},cmd:function(){return Ue},get_command:function(){return Ue.get()},set_command:function(e){Ae(function n(){Ue.set(e)});return ve},set_position:function(e,n){Ae(function t(){Ue.position(e,n)});return ve},get_position:function(){return Ue.position()},insert:function(e,n){if(typeof e==="string"){Ae(function t(){var r=ve.is_bottom();Ue.insert(e,n);if(Ne.scrollOnEcho||r){_()}});return ve}else{throw new Error(sprintf(he().notAString,"insert"))}},set_prompt:function(n){Ae(function t(){if(k("prompt",n)){if(e.isFunction(n)){Ue.prompt(function(e){n(e,ve)})}else{Ue.prompt(n)}Me.top().prompt=n}});return ve},get_prompt:function(){return Me.top().prompt},set_mask:function(e){Ae(function n(){Ue.mask(e===true?Ne.maskChar:e)});return ve},get_output:function(n){if(n){return be}else{return e.map(be,function(n){return e.isFunction(n[0])?n[0]():n[0]}).join("\n")}},resize:function(n,t){if(!ve.is(":visible")){ve.stopTime("resize");ve.oneTime(500,"resize",function(){ve.resize(n,t)})}else{if(n&&t){ve.width(n);ve.height(t)}n=ve.width();t=ve.height();if(typeof Ne.numChars!=="undefined"&&typeof Ne.numRows!=="undefined"){return}Fe=Y();var r=G(ve,Fe);var i=X(ve,Fe);if(r!==xe||i!==Te){xe=r;Te=i;Ue.resize(xe);R();var o=Me.top();if(e.isFunction(o.resize)){o.resize.call(ve,ve)}else if(e.isFunction(Ne.onResize)){Ne.onResize.call(ve,ve)}_()}}return ve},flush:function(){try{var n=ve.is_bottom();var t;e.each(x,function(n,r){if(r===T){t=e("<div></div>")}else if(e.isFunction(r)){t.appendTo(_e);r(t)}else{e("<div/>").html(r).appendTo(t).width("100%")}});if(Ne.outputLimit>=0){var r;if(Ne.outputLimit===0){r=ve.rows()}else{r=Ne.outputLimit}var i=_e.find("div div");if(i.length+1>r){var o=i.length-r+1;var a=i.slice(0,o);var s=a.parent();a.remove();s.each(function(){var n=e(this);if(n.is(":empty")){n.remove()}})}}if(Ne.scrollOnEcho||n){_()}x=[]}catch(n){if(e.isFunction(Ne.exceptionHandler)){Ne.exceptionHandler.call(ve,n,"TERMINAL (Flush)")}else{alert("[Flush] "+w(n)+"\n"+n.stack)}}return ve},update:function(e,n){Ae(function t(){if(e<0){e=be.length+e}if(!be[e]){ve.error("Invalid line number "+e)}else{if(n===null){be.splice(e,1)}else{be[e][0]=n}R()}});return ve},last_index:function(){return be.length-1},echo:function(n,t){function r(n){try{var r=e.extend({flush:true,raw:Ne.raw,finalize:e.noop,keepWords:false,formatters:true},t||{});if(r.raw){(function(e){r.finalize=function(n){n.addClass("raw");e(n)}})(r.finalize)}if(r.flush){if(x.length){ve.flush()}x=[]}if(typeof n==="function"){n=n.bind(ve)}C(n,r);be.push([n,e.extend(r,{exec:false})]);if(r.flush){ve.flush()}}catch(n){if(e.isFunction(Ne.exceptionHandler)){Ne.exceptionHandler.call(ve,n,"TERMINAL (echo)")}else{alert("[Terminal.echo] "+w(n)+"\n"+n.stack)}}}try{if(t&&e.isFunction(t.finalize)){t.finalize(e("<div/>"))}if(e.isFunction(n.then)){e.when(n).done(r)}else{r(n)}}catch(e){b(e,"USER:echo(finalize)")}return ve},error:function(n,t){t=e.extend({},t,{raw:false,formatters:false});var r=e.terminal.escape_brackets(n).replace(/\\$/,"&#92;").replace(S,"]$1[[;;;error]");return ve.echo("[[;;;error]"+r+"]",t)},exception:function(n,t){var r=w(n);if(t){r="&#91;"+t+"&#93;: "+r}if(r){ve.error(r,{finalize:function(e){e.addClass("exception message")},keepWords:true})}if(typeof n.fileName==="string"){ve.pause(Ne.softPause);e.get(n.fileName,function(e){var t=n.lineNumber-1;var r=e.split("\n")[t];if(r){ve.error("["+n.lineNumber+"]: "+r)}ve.resume()},"text")}if(n.stack){var i=e.terminal.escape_brackets(n.stack);ve.echo(i.split(/\n/g).map(function(e){return"[[;;;error]"+e.replace(S,function(e){return"]"+e+"[[;;;error]"})+"]"}).join("\n"),{finalize:function(e){e.addClass("exception stack-trace")},formatters:false})}},scroll:function(e){var n;e=Math.round(e);if(ge.prop){if(e>ge.prop("scrollTop")&&e>0){ge.prop("scrollTop",0)}n=ge.prop("scrollTop");ge.scrollTop(n+e)}else{if(e>ge.attr("scrollTop")&&e>0){ge.attr("scrollTop",0)}n=ge.attr("scrollTop");ge.scrollTop(n+e)}return ve},logout:function(e){if(je){throw new Error(sprintf(he().notWhileLogin,"logout"))}Ae(function t(){if(e){var r=Ce.pop();ve.set_token(n,true);ve.login.apply(ve,r)}else if(Me.size()===1&&ve.token()){ve.logout(true)}else{while(Me.size()>1){if(ve.token()){ve.logout(true).pop().pop()}else{ve.pop()}}}});return ve},token:function(e){return $e.get(ve.prefix_name(e)+"_token")},set_token:function(e,n){var t=ve.prefix_name(n)+"_token";if(typeof e==="undefined"){$e.remove(t,e)}else{$e.set(t,e)}return ve},get_token:function(e){return ve.token(e)},login_name:function(e){return $e.get(ve.prefix_name(e)+"_login")},name:function(){return Me.top().name},prefix_name:function(e){var n=(Ne.name?Ne.name+"_":"")+ke;if(e&&Me.size()>1){var t=Me.map(function(e){return e.name||""}).slice(1).join("_");if(t){n+="_"+t}}return n},read:function(n,t){var r=new e.Deferred;ve.push(function(n){ve.pop();if(e.isFunction(t)){t(n)}r.resolve(n)},{prompt:n});return r.promise()},push:function(t,r){Le(function i(){r=r||{};var o={infiniteLogin:false};var a=e.extend({},o,r);if(!a.name&&ye){a.name=ye.name}if(a.prompt===n){a.prompt=(a.name||">")+" "}var s=Me.top();if(s){s.mask=Ue.mask()}var l=De;function f(){Ne.onPush.call(ve,s,Me.top(),ve);J()}v(t,!!r.login,function(n){Me.push(e.extend({},n,a));if(a.completion===true){if(e.isArray(n.completion)){Me.top().completion=n.completion}else if(!n.completion){Me.top().completion=false}}if(a.login){var r;var i=e.type(a.login);if(i==="function"){r=a.infiniteLogin?e.noop:ve.pop;ve.login(a.login,a.infiniteLogin,f,r)}else if(e.type(t)==="string"&&i==="string"||i==="boolean"){r=a.infiniteLogin?e.noop:ve.pop;ve.login(y(t,a.login),a.infiniteLogin,f,r)}}else{f()}if(!l&&ve.enabled()){ve.resume()}})});return ve},pop:function(t,r){if(t!==n){j(t)}var i=ve.token(true);var o;if(Me.size()===1){o=Me.top();if(Ne.login){if(!r){Ne.onPop.call(ve,o,null,ve)}H();if(e.isFunction(Ne.onExit)){try{Ne.onExit.call(ve,ve)}catch(e){b(e,"onExit")}}}else{ve.error(he().canExitError)}}else{if(i){W()}var a=Me.pop();o=Me.top();J();if(!r){Ne.onPop.call(ve,a,o)}if(je&&ve.get_prompt()!==he().login+": "){je=false}if(e.isFunction(a.onExit)){try{a.onExit.call(ve,ve)}catch(e){b(e,"onExit")}}ve.set_mask(o.mask)}return ve},option:function(n,t){if(typeof t==="undefined"){if(typeof n==="string"){return Ne[n]}else if(typeof n==="object"){e.each(n,function(e,n){Ne[e]=n})}}else{Ne[n]=t}return ve},level:function(){return Me.size()},reset:function(){Ae(function e(){ve.clear();while(Me.size()>1){Me.pop()}Q()});return ve},purge:function(){Ae(function n(){var t=ve.prefix_name()+"_";var r=$e.get(t+"interpreters");if(r){e.each(JSON.parse(r),function(e,n){$e.remove(n+"_commands");$e.remove(n+"_token");$e.remove(n+"_login")})}Ue.purge();$e.remove(t+"interpreters")});return ve},destroy:function(){Ae(function n(){Ue.destroy().remove();_e.remove();Ye.remove();e(document).unbind(".terminal_"+ve.id());e(window).unbind(".terminal_"+ve.id());ve.unbind("click wheel mousewheel mousedown mouseup");ve.removeData("terminal").removeClass("terminal").unbind(".terminal");if(Ne.width){ve.css("width","")}if(Ne.height){ve.css("height","")}e(window).off("blur",Ze).off("focus",Qe);ve.find(".terminal-fill").remove();le.remove(ke);if(Ke){Ke.unobserve(ve[0])}if(Je){Je.disconnect()}ve.resizer("unbind");if(!le.length()){e(window).off("hashchange")}});return ve},scroll_to_bottom:function(){_();return ve},is_bottom:function(){if(Ne.scrollBottomOffset===-1){return false}else{var n,t,r;if(ve.is("body")){n=e(document).height();t=e(window).scrollTop();r=window.innerHeight}else{n=ge[0].scrollHeight;t=ge.scrollTop();r=ge.outerHeight()}var i=n-Ne.scrollBottomOffset;return t+r>i}}},function(e,n){return function(){try{return n.apply(ve,[].slice.apply(arguments))}catch(n){if(e!=="exec"&&e!=="resume"){b(n,"TERMINAL")}if(!Ne.exceptionHandler){throw n}}}}));if(Ne.ignoreSystemDescribe===true){Ne.describe=false}if(Ne.width){ve.width(Ne.width)}if(Ne.height){ve.height(Ne.height)}ge=ve.scroll_element();e(document).bind("ajaxSend.terminal_"+ve.id(),function(e,n){se.push(n)});var Ye=e('<div class="terminal-wrapper"/>').appendTo(ve);e('<div class="terminal-fill"/>').appendTo(ve);_e=e("<div>").addClass("terminal-output").attr("role","log").appendTo(Ye);ve.addClass("terminal");if(Ne.login&&e.isFunction(Ne.onBeforeLogin)){try{if(Ne.onBeforeLogin.call(ve,ve)===false){Be=false}}catch(e){b(e,"onBeforeLogin");if(!Ne.exceptionHandler){throw e}}}var Ge;if(typeof r==="string"){Ge=r}else if(r instanceof Array){for(var Xe=0,Ve=r.length;Xe<Ve;++Xe){if(typeof r[Xe]==="string"){Ge=r[Xe];break}}}if(Ge&&(typeof Ne.login==="string"||Ne.login===true)){Ne.login=y(Ge,Ne.login)}le.append(ve);ve.on("focus.terminal","textarea",function(e){if(e.originalEvent!==n){ve.focus(true,!ve.enabled())}});function Qe(){if(We){ve.focus()}}function Ze(){We=He;ve.disable().find("textarea").trigger("blur",[true])}function en(e){e=e.originalEvent;if(e.clipboardData){if(ve.enabled()){var n=e.clipboardData.items;if(n){for(var t=0;t<n.length;t++){if(n[t].type.indexOf("image")!==-1){var r=n[t].getAsFile();var i=window.URL||window.webkitURL;var o=i.createObjectURL(r);ve.echo('<img src="'+o+'"/>',{raw:true})}}}}}}e(document).on("paste.terminal_"+ve.id(),en);v(r,!!Ne.login,function(t){if(Ne.completion&&typeof Ne.completion!=="boolean"||!Ne.completion){t.completion="settings"}var r=e.extend({},ie,Ne.keymap||{});Me=new g(e.extend({},Ne.extra,{name:Ne.name,prompt:Ne.prompt,keypress:Ne.keypress,keydown:Ne.keydown,resize:Ne.onResize,greetings:Ne.greetings,mousewheel:Ne.mousewheel,keymap:r},t));Ue=e("<div/>").appendTo(Ye).cmd({prompt:Ne.prompt,history:Ne.memory?"memory":Ne.history,historyFilter:Ne.historyFilter,historySize:Ne.historySize,width:"100%",enabled:false,keydown:oe,keymap:r,clickTimeout:Ne.clickTimeout,keypress:function(n){var t=Me.top();if(He&&(!De||!Ne.pauseEvents)){if(e.isFunction(t.keypress)){return t.keypress.call(ve,n,ve)}else if(e.isFunction(Ne.keypress)){return Ne.keypress.call(ve,n,ve)}}},onCommandChange:function(n){if(e.isFunction(Ne.onCommandChange)){try{Ne.onCommandChange.call(ve,n,ve)}catch(e){b(e,"onCommandChange");if(!Ne.exceptionHandler){throw e}}}_()},commands:$});if(He&&ve.is(":visible")&&!B){ve.focus(n,true)}else{ve.disable()}function i(n){n=n.originalEvent;var t=document.elementFromPoint(n.pageX,n.pageY);if(!e(t).closest(".terminal").length&&ve.enabled()){ve.disable()}}ve.oneTime(100,function(){e(document).bind("click.terminal_"+ve.id(),i).bind("contextmenu.terminal_"+ve.id(),i)});var o=e(window);document.addEventListener("resume",function(){ve.disable()});if(B){ve.click(function(){if(!qe){if(!ve.enabled()){ve.focus();Ue.enable()}else{ve.disable()}}})}else{o.on("focus.terminal_"+ve.id(),Qe).on("blur.terminal_"+ve.id(),Ze);(function(){var n=0;var t;var r="click_"+ve.id();function i(){if(t.is(".terminal")||t.is(".terminal-wrapper")){var e=ve.get_command().length;ve.set_position(e)}else if(t.closest(".prompt").length){ve.set_position(0)}n=0}ve.mousedown(function(n){t=e(n.target)}).mouseup(function(){if(M()===""){if(++n===1){if(!qe){Ue.enable();if(!He){ve.focus();n=0}else{var e=Ne.clickTimeout;ve.oneTime(e,r,i)}}}else{ve.stopTime(r);n=0}}}).dblclick(function(){n=0;ve.stopTime(r)})})();(function(){var e=ve.find("textarea");ve.on("mousedown.terminal",function(n){if(n.originalEvent.button===2){if(!ve.enabled()){ve.enable()}var t=Ue.offset();e.css({left:n.pageX-t.left-5,top:n.pageY-t.top-5})}});ve.bind("contextmenu",function(){ve.oneTime(100,function(){e.css({left:"",top:""})})})})()}ve.delegate(".exception a","click",function(n){var t=e(this).attr("href");if(t.match(/:[0-9]+$/)){n.preventDefault();f(t)}});if(ve.is(":visible")){xe=ve.cols();Ue.resize(xe);if(!Fe){Fe=Y()}Te=X(ve,Fe)}Re.resolve();if(Ne.login){ve.login(Ne.login,true,Q)}else{Q()}function a(){if(ve.is(":visible")){var e=ve.width();var n=ve.height();if(Pe!==n||ze!==e){ve.resize()}Pe=n;ze=e}}if(ve.is(":visible")){ve.resizer(a)}function s(){if(Ke){Ke.unobserve(ve[0])}var n;Ke=new IntersectionObserver(function(){if(ve.is(":visible")){ve.resizer("unbind").resizer(a);a();if(n){ve.enabled()}}else{n=e.terminal.active()===ve&&ve.enabled();ve.disable()}},{root:document.body});Ke.observe(ve[0])}var l=!!ve.closest("body").length;var c=window.MutationObserver||window.WebKitMutationObserver;if(window.IntersectionObserver){if(c){Je=new c(function(){if(ve.closest("body").length){if(!l){ve.scroll_to_bottom();s()}l=true}else if(l){l=false}});Je.observe(document.body,{childList:true})}if(l){s()}}function u(n){var t=le.get()[n[0]];if(t&&ke===t.id()){if(n[2]){try{if(De){var r=e.Deferred();N.push(function(){return t.exec(n[2]).done(function(){t.save_state(n[2],true,n[1]);r.resolve()})});return r.promise()}else{return t.exec(n[2]).done(function(){t.save_state(n[2],true,n[1])})}}catch(n){var i=t.settings();if(e.isFunction(i.exceptionHandler)){i.exceptionHandler.call(ve,n,"EXEC HASH")}else{var o=e.terminal.escape_brackets(Ee);var a="Error while exec with command "+o;t.error(a).exception(n)}}}}}if(Ne.execHash){if(location.hash){setTimeout(function(){try{var e=location.hash.replace(/^#/,"");ce=JSON.parse(decodeURIComponent(e));var n=0;(function e(){var t=ce[n++];if(t){u(t).done(e)}else{ue=true}})()}catch(e){}})}else{ue=true}}else{ue=true}var p=false;e(document).bind("keydown.terminal_"+ve.id(),function(e){if(e.shiftKey){p=true}}).bind("keyup.terminal_"+ve.id(),function(e){if(e.shiftKey||e.which===16){p=false}});function m(n,t){if(!p){var r=Me.top();var i;if(e.isFunction(r.mousewheel)){i=r.mousewheel(n,t,ve);if(i===false){return}}else if(e.isFunction(Ne.mousewheel)){i=Ne.mousewheel(n,t,ve);if(i===false){return}}if(t>0){ve.scroll(-40)}else{ve.scroll(40)}}}if(e.event.special.mousewheel){ve.on("mousewheel",function(e,n){m(e,n);e.preventDefault()})}else{var d;if("onwheel"in document.createElement("div")){d="wheel"}else if(document.onmousewheel!==n){d="mousewheel"}else{d="DOMMouseScroll"}ve.on(d,function(e){var n;if(d==="mousewheel"){n=-1/40*e.originalEvent.wheelDelta}else{n=e.originalEvent.deltaY||e.originalEvent.detail}m(e,-n);e.preventDefault()})}});ve.data("terminal",ve);return ve}});